// gJ=HeɂO

package f01;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0104 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=10000,FR=200,n=4;
	double Div=1.0E4,dt=0.05,step=2.0*FR/n;
	double r=2.5,m=0.2;
	double[]p0={0.2,1.0};
	double[]FP=new double[2];
	double u_min=0.0,u_max=0.4;
	double v_min=0.0,v_max=2.0;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[0]*(1-x[1]);
		xx[1]=(r*x[0]-m)*x[1];
		return xx;
	}

	private double[]getFP()
	{	double[]fp=new double[2];
		fp[0]=m/r;
		fp[1]=1.0;
		return fp;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double[]p=new double[2];
		for(int sx=-FR;sx<=FR;sx++)
		{	p[0]=setSx(sx);
			for(int sy=-FR;sy<=FR;sy++)
			{	p[1]=setSy(sy);
				double[]pp=diff(p,2);
				if(pp[0]>=0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[1]);
				if(pp[0]>=0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[2]);
				if(pp[0]<0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[6]);
				if(pp[0]<0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[4]);
			}
		}

		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(step*i),-FR,-FR+XMath.fint(step*i),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(step*i),FR,-FR+XMath.fint(step*i),XColor.Color16[8]);

		FP=getFP();

		int D=XMath.fint(step);
		for(int sx=-FR+D;sx<FR;sx=sx+D)
		{	p0[0]=setSx(sx);
			p=p0;
			Point sp_=new Point(sx,getSy(p[1]));
			XG.plus(sp_,4,XColor.Color16[0],3);
			for(int n=0;n<NL;n++)
			{	double[]pp=rungeKutta(p,2);
				p=pp;
				double p2=p[0]*p[0]+p[1]*p[1];
				if(p2>=Div)
					break;
				Point sp=new Point(getSx(p[0]),getSy(p[1]));
				if(n!=0&&Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR
					&&Math.abs(sp_.x)<=FR&&Math.abs(sp_.y)<=FR)
					XG.line(sp_,sp,XColor.Color16[0]);
				sp_=sp;
			}
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.cross(getSx(FP[0]),getSy(FP[1]),3,XColor.Color16[0],3);

		XG.string2(getSx(FP[0])-24,getSy(FP[1])+12,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string2(FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-9,-FR-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-23,-FR-32,""+XMath.fdouble((u_min+u_max)/2,2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-27,-FR-32,""+u_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,""+XMath.fdouble((v_min+v_max)/2,2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		int xx=112,yy=192;
		XG.rectangleF(xx,yy,xx+76,yy-124,XColor.Color16[7]);
		XG.rectangleF(xx+8,yy-6,xx+38,yy-28,XColor.Color16[1]);
		XG.arrow(xx+48,yy-29,xx+68,yy-9,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-36,xx+38,yy-58,XColor.Color16[2]);
		XG.arrow(xx+48,yy-39,xx+68,yy-59,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-66,xx+38,yy-88,XColor.Color16[6]);
		XG.arrow(xx+68,yy-69,xx+48,yy-89,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-96,xx+38,yy-118,XColor.Color16[4]);
		XG.arrow(xx+68,yy-119,xx+48,yy-99,XColor.Color16[0],1,16);

		XG.string(10,140,"r="+r,XColor.Color16[0],16);
		XG.string(10,160,"m="+m,XColor.Color16[0],16);
		XG.string(10,300,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0104()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"gJ=HeɂO");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0104 app=new F0104();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}