// 3ϐΏԌnfɂJIX

package f01;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0107a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=400000,FR=200,n=4;
	double Div=1.0E4,dt=0.02;
	double h0=0.09,h1=0.04;
	double r1=0.8,m1=0.64,r2=1.0,m2=0.8;
	double[]p0={0.3,0.3,0.02};
	double[][]FP=new double[3][3];
	double u_min=0.0,u_max=1.0;
	double v_min=0.0,v_max=0.4;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		double f0=x[0]/(h0+x[0]);
		double f1=x[1]*x[1]/(h1*h1+x[1]*x[1]);
		xx[0]=x[0]*(1-x[0])-f0*x[1];
		xx[1]=(r1*f0-m1)*x[1]-f1*x[2];
		xx[2]=(r2*f1-m2)*x[2];
		return xx;
	}

	private double[][]getFP(int n)
	{	double[][]fp=new double[3][n];
		fp[0][1]=fp[1][1]=Math.sqrt(m2/(r2-m2))*h1;
		double f1=fp[0][1]/(h1*h1+fp[0][1]*fp[0][1]);
		double k1=h0-1;
		double k0=fp[0][1]-h0;
		double[][]x=new double[2][2];
		x=XAlgebra.roots2dEq(k1,k0);
		fp[0][0]=x[0][0];
		double f0=fp[0][0]/(h0+fp[0][0]);
		fp[0][2]=(r1*f0-m1)/f1;
		fp[1][0]=x[1][0];
		f0=fp[1][0]/(h0+fp[1][0]);
		fp[1][2]=(r1*f0-m1)/f1;
		fp[2][2]=0.0;
		fp[2][0]=m1/(r1-m1)*h0;
		fp[2][1]=(1-fp[2][0])*(h0+fp[2][0]);
		return fp;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		FP=getFP(3);

		double D=2.0*FR/n;
		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(D*i),-FR,-FR+XMath.fint(D*i),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(D*i),FR,-FR+XMath.fint(D*i),XColor.Color16[8]);

		double[]p=p0;
		Point sp_=new Point(getSx(p[0]),getSy(p[1]));
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,3);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
			if(p2>=Div)
				break;
			Point sp=new Point(getSx(p[0]),getSy(p[1]));
			if(n>NL/10&&Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR)
				XG.line(sp_,sp,XColor.Color16[0]);
			sp_=sp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(FR-59,FR-40,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.cross(getSx(FP[0][0]),getSy(FP[0][1]),3,XColor.Color16[0],3);

		XG.string2(getSx(FP[0][0])+4,getSy(FP[0][1])+4,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string2(FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-9,-FR-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-23,-FR-32,""+u_max/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-26,-FR-32,""+u_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,""+v_max/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"h0="+h0,XColor.Color16[0],16);
		XG.string(10,160,"h1="+h1,XColor.Color16[0],16);
		XG.string(10,180,"r1="+r1,XColor.Color16[0],16);
		XG.string(10,200,"m1="+m1,XColor.Color16[0],16);
		XG.string(10,220,"r2="+r2,XColor.Color16[0],16);
		XG.string(10,240,"m2="+m2,XColor.Color16[0],16);
		XG.string(10,280,"p0=("+p0[0]+","+p0[1]+","+p0[2]+")",
			XColor.Color16[0],16);
		XG.string(10,320,"FP0=("+XMath.fdouble(FP[0][0],3)+","
			+XMath.fdouble(FP[0][1],3)+","+XMath.fdouble(FP[0][2],3)+")",
			XColor.Color16[0],16);
		XG.string(10,340,"FP1=("+XMath.fdouble(FP[1][0],3)+","
			+XMath.fdouble(FP[1][1],3)+","+XMath.fdouble(FP[1][2],3)+")",
			XColor.Color16[0],16);
		XG.string(10,360,"FP2=("+XMath.fdouble(FP[2][0],3)+","
			+XMath.fdouble(FP[2][1],3)+","+XMath.fdouble(FP[2][2],3)+")",
			XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0107a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"3ϐΏԌnfɂJIX");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0107a app=new F0107a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}