// 2ϐWXeBbNɂ2̌Œ_ւ̎

package f02;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0201a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=10000,FR=200,n=4;
	double Div=1.0E4,dt=0.01,step=2.0*FR/n;
	double a0=0.1,a1=0.1,c0=2.0,c1=2.0;
	double r=1.0;
	double[][]FP=new double[4][2];
	double u_min=0.0,u_max=1.0;
	double v_min=0.0,v_max=1.0;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=a0+x[0]*(1-x[0]-c0*x[1]);
		xx[1]=a1+x[1]*(r*(1-x[1])-c1*x[0]);
		return xx;
	}

	private double[][]getFP()
	{	double[][]fp=new double[4][2];
		double k4=r-c0*c1;
		double k3=c0*c1-r*(2-c0);
		double k2=r*(1-2*a0-c0)+c0*(a0*c1-a1*c0);
		double k1=a0*r*(2-c0);
		double k0=a0*a0*r;
		double[][]x=new double[4][2];
		x=XAlgebra.roots4dEq(k3/k4,k2/k4,k1/k4,k0/k4);
		fp[0][0]=x[0][0];
		fp[0][1]=(a0+fp[0][0]-fp[0][0]*fp[0][0])/(c0*fp[0][0]);
		fp[1][0]=x[1][0];
		fp[1][1]=(a0+fp[1][0]-fp[1][0]*fp[1][0])/(c0*fp[1][0]);
		fp[2][0]=x[2][0];
		fp[2][1]=(a0+fp[2][0]-fp[2][0]*fp[2][0])/(c0*fp[2][0]);
		fp[3][0]=x[3][0];
		fp[3][1]=(a0+fp[3][0]-fp[3][0]*fp[3][0])/(c0*fp[3][0]);
		return fp;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		FP=getFP();

		double[]p=new double[2];
		for(int sx=-FR;sx<=FR;sx++)
		{	p[0]=setSx(sx);
			for(int sy=-FR;sy<=FR;sy++)
			{	p[1]=setSy(sy);
				double[]pp=diff(p,2);
				if(pp[0]>=0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[1]);
				if(pp[0]>=0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[2]);
				if(pp[0]<0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[6]);
				if(pp[0]<0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[4]);
			}
		}

		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(step*i),-FR,-FR+XMath.fint(step*i),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(step*i),FR,-FR+XMath.fint(step*i),XColor.Color16[8]);

		double[]p0=new double[2];
		int D=XMath.fint(step);
		for(int sx=-FR;sx<=FR;sx=sx+D)
		{	p0[0]=setSx(sx);
			for(int sy=-FR;sy<=FR;sy=sy+D)
			{	p0[1]=setSy(sy);
				if(sx!=sy)
				{	p=p0;
					Point sp_=new Point(sx,sy);
					XG.plus(sp_,4,XColor.Color16[0],3);
					for(int n=0;n<NL;n++)
					{	double[]pp=rungeKutta(p,2);
						p=pp;
						double p2=p[0]*p[0]+p[1]*p[1];
						if(p2>=Div)
							break;
						Point sp=new Point(getSx(p[0]),getSy(p[1]));
						if(Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR
							&&Math.abs(sp_.x)<=FR&&Math.abs(sp_.y)<=FR)
							XG.line(sp_,sp,XColor.Color16[0]);
						sp_=sp;
					}
				}
			}
		}

		XG.rectangle(-FR,-FR,FR,FR,XColor.Color16[0]);
		XG.line(-FR,-FR,FR,FR,XColor.Color16[0]);

		XG.cross(getSx(FP[0][0]),getSy(FP[0][1]),4,XColor.Color16[0],3);
		XG.cross(getSx(FP[1][0]),getSy(FP[1][1]),4,XColor.Color16[0],3);
		XG.cross(getSx(FP[2][0]),getSy(FP[2][1]),4,XColor.Color16[0],3);

		XG.string2(FR-96,FR-40,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(getSx(FP[0][0])+6,getSy(FP[0][1])+2,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(FP[0][0])+22,getSy(FP[0][1])-2,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,16);
		XG.string2(getSx(FP[1][0])+8,getSy(FP[1][1])-6,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(FP[1][0])+24,getSy(FP[1][1])-10,"1",XColor.Color16[0],
			"Arial",Font.PLAIN,16);
		XG.string2(getSx(FP[2][0])+4,getSy(FP[2][1])+6,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(FP[2][0])+20,getSy(FP[2][1])+2,"2",XColor.Color16[0],
			"Arial",Font.PLAIN,16);

		XG.string2(FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-8,-FR-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-22,-FR-32,"0.5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-26,-FR-32,"1.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,"0.5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,"1.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		int xx=112,yy=92;
		XG.rectangleF(xx,yy,xx+76,yy-124,XColor.Color16[7]);
		XG.rectangleF(xx+8,yy-6,xx+38,yy-28,XColor.Color16[1]);
		XG.arrow(xx+48,yy-29,xx+68,yy-9,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-36,xx+38,yy-58,XColor.Color16[2]);
		XG.arrow(xx+48,yy-39,xx+68,yy-59,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-66,xx+38,yy-88,XColor.Color16[6]);
		XG.arrow(xx+68,yy-69,xx+48,yy-89,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-96,xx+38,yy-118,XColor.Color16[4]);
		XG.arrow(xx+68,yy-119,xx+48,yy-99,XColor.Color16[0],1,16);

		XG.string(10,140,"a0="+a0,XColor.Color16[0],16);
		XG.string(10,160,"a1="+a1,XColor.Color16[0],16);
		XG.string(10,180,"c0="+c0,XColor.Color16[0],16);
		XG.string(10,200,"c1="+c1,XColor.Color16[0],16);
		XG.string(10,220,"r="+r,XColor.Color16[0],16);
		XG.string(10,300,"FP0=("+XMath.fdouble(FP[0][0],3)+","
			+XMath.fdouble(FP[0][1],3)+")",XColor.Color16[0],16);
		XG.string(10,320,"FP1=("+XMath.fdouble(FP[1][0],3)+","
			+XMath.fdouble(FP[1][1],3)+")",XColor.Color16[0],16);
		XG.string(10,340,"FP2=("+XMath.fdouble(FP[2][0],3)+","
			+XMath.fdouble(FP[2][1],3)+")",XColor.Color16[0],16);
		XG.string(10,360,"FP3=("+XMath.fdouble(FP[3][0],3)+","
			+XMath.fdouble(FP[3][1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0201a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"2ϐWXeBbNɂ2̌Œ_ւ̎");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0201a app=new F0201a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}