// 2ϐWXeBbN2̌Œ_ɂŗLxNg

package f02;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0201b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=200,n=4;
	double Div=1.0E4,ks=0.095,step=2.0*FR/n;
	double a0=0.1,a1=0.1,c0=2.0,c1=2.0;
	double r=1.0;
	double[][]FP=new double[4][2];
	double[][][]LM=new double[4][2][2];
	double[][][]EV=new double[4][2][2];
	double u_min=0.0,u_max=1.0;
	double v_min=0.0,v_max=1.0;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=a0+x[0]*(1-x[0]-c0*x[1]);
		xx[1]=a1+x[1]*(r*(1-x[1])-c1*x[0]);
		return xx;
	}

	private double[][]getFP()
	{	double[][]fp=new double[4][2];
		double k4=r-c0*c1;
		double k3=c0*c1-r*(2-c0);
		double k2=r*(1-2*a0-c0)+c0*(a0*c1-a1*c0);
		double k1=a0*r*(2-c0);
		double k0=a0*a0*r;
		double[][]x=new double[4][2];
		x=XAlgebra.roots4dEq(k3/k4,k2/k4,k1/k4,k0/k4);
		fp[0][0]=x[0][0];
		fp[0][1]=(a0+fp[0][0]-fp[0][0]*fp[0][0])/(c0*fp[0][0]);
		fp[1][0]=x[1][0];
		fp[1][1]=(a0+fp[1][0]-fp[1][0]*fp[1][0])/(c0*fp[1][0]);
		fp[2][0]=x[2][0];
		fp[2][1]=(a0+fp[2][0]-fp[2][0]*fp[2][0])/(c0*fp[2][0]);
		fp[3][0]=x[3][0];
		fp[3][1]=(a0+fp[3][0]-fp[3][0]*fp[3][0])/(c0*fp[3][0]);
		return fp;
	}

	private double[][][]getLM()
	{	double[][][]m=new double[4][2][2];
		for(int i=0;i<4;i++)
		{	double k1=-(1+r-(2+c1)*FP[i][0]-(2*r+c0)*FP[i][1]);
			double k0=r-(2*r+c1)*FP[i][0]-(2+c0)*r*FP[i][1]
				+2*c1*FP[i][0]*FP[i][0]+2*c0*r*FP[i][1]*FP[i][1]+4*r*FP[i][0]*FP[i][1];
			m[i]=XAlgebra.roots2dEq(k1,k0);
		}
		return m;
	}

	private double[][][]getEV()
	{	double[][][]v=new double[4][2][2];
		for(int i=0;i<4;i++)
		{	for(int j=0;j<2;j++)
			{	v[i][j][0]=c0*FP[i][0];
				v[i][j][1]=1-2*FP[i][0]-c0*FP[i][1]-LM[i][j][0];
				double s=Math.sqrt(v[i][j][0]*v[i][j][0]+v[i][j][1]*v[i][j][1]);
				v[i][j][0]=v[i][j][0]/s;
				v[i][j][1]=v[i][j][1]/s;
				double ss=ks*Math.pow(LM[i][j][0]*LM[i][j][0]+LM[i][j][1]*LM[i][j][1],1.0/8);
				v[i][j][0]=ss*v[i][j][0];
				v[i][j][1]=ss*v[i][j][1];
			}
		}
		return v;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		FP=getFP();
		LM=getLM();
		EV=getEV();

		double[]p=new double[2];
		for(int sx=-FR;sx<=FR;sx++)
		{	p[0]=setSx(sx);
			for(int sy=-FR;sy<=FR;sy++)
			{	p[1]=setSy(sy);
				double[]pp=diff(p,2);
				if(pp[0]>=0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[1]);
				if(pp[0]>=0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[2]);
				if(pp[0]<0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[6]);
				if(pp[0]<0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[4]);
			}
		}

		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(i*step),-FR,-FR+XMath.fint(i*step),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(i*step),FR,-FR+XMath.fint(i*step),XColor.Color16[8]);

		for(int i=0;i<3;i++)
		{	int sx0=getSx(FP[i][0]);
			int sy0=getSy(FP[i][1]);
			for(int j=0;j<2;j++)
			{	int sx1=getSx(FP[i][0]+EV[i][j][0]);
				int sy1=getSy(FP[i][1]+EV[i][j][1]);
				int sx2=getSx(FP[i][0]-EV[i][j][0]);
				int sy2=getSy(FP[i][1]-EV[i][j][1]);
				if(LM[i][j][0]>=0)
				{	XG.arrow(sx0,sy0,sx1,sy1,XColor.Color16[0],3,20);
					XG.arrow(sx0,sy0,sx2,sy2,XColor.Color16[0],3,20);
				}
				else
				{	XG.arrow(sx1,sy1,sx0,sy0,XColor.Color16[0],3,20);
					XG.arrow(sx2,sy2,sx0,sy0,XColor.Color16[0],3,20);
				}
			}
		}

		XG.rectangle(-FR,-FR,FR,FR,XColor.Color16[0]);
		XG.line(-FR,-FR,FR,FR,XColor.Color16[0]);

		XG.cross(getSx(FP[0][0]),getSy(FP[0][1]),4,XColor.Color16[0],3);
		XG.cross(getSx(FP[1][0]),getSy(FP[1][1]),4,XColor.Color16[0],3);
		XG.cross(getSx(FP[2][0]),getSy(FP[2][1]),4,XColor.Color16[0],3);

		XG.string2(FR-96,FR-40,"(b)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(getSx(FP[0][0])-12,getSy(FP[0][1])+14,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(FP[0][0])+4,getSy(FP[0][1])+10,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,16);
		XG.string2(getSx(FP[1][0])+16,getSy(FP[1][1])-12,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(FP[1][0])+32,getSy(FP[1][1])-16,"1",XColor.Color16[0],
			"Arial",Font.PLAIN,16);
		XG.string2(getSx(FP[2][0])+10,getSy(FP[2][1])-12,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(FP[2][0])+26,getSy(FP[2][1])-16,"2",XColor.Color16[0],
			"Arial",Font.PLAIN,16);

		XG.string2(FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-8,-FR-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-22,-FR-32,"0.5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-26,-FR-32,"1.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,"0.5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,"1.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		int xx=112,yy=92;
		XG.rectangleF(xx,yy,xx+76,yy-124,XColor.Color16[7]);
		XG.rectangleF(xx+8,yy-6,xx+38,yy-28,XColor.Color16[1]);
		XG.arrow(xx+48,yy-29,xx+68,yy-9,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-36,xx+38,yy-58,XColor.Color16[2]);
		XG.arrow(xx+48,yy-39,xx+68,yy-59,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-66,xx+38,yy-88,XColor.Color16[6]);
		XG.arrow(xx+68,yy-69,xx+48,yy-89,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-96,xx+38,yy-118,XColor.Color16[4]);
		XG.arrow(xx+68,yy-119,xx+48,yy-99,XColor.Color16[0],1,16);

		XG.string(10,140,"a0="+a0,XColor.Color16[0],16);
		XG.string(10,160,"a1="+a1,XColor.Color16[0],16);
		XG.string(10,180,"c0="+c0,XColor.Color16[0],16);
		XG.string(10,200,"c1="+c1,XColor.Color16[0],16);
		XG.string(10,220,"r="+r,XColor.Color16[0],16);
		XG.string(10,300,"FP0=("+XMath.fdouble(FP[0][0],3)+","
			+XMath.fdouble(FP[0][1],3)+")",XColor.Color16[0],16);
		XG.string(10,320,"FP1=("+XMath.fdouble(FP[1][0],3)+","
			+XMath.fdouble(FP[1][1],3)+")",XColor.Color16[0],16);
		XG.string(10,340,"FP2=("+XMath.fdouble(FP[2][0],3)+","
			+XMath.fdouble(FP[2][1],3)+")",XColor.Color16[0],16);
		XG.string(10,360,"FP3=("+XMath.fdouble(FP[3][0],3)+","
			+XMath.fdouble(FP[3][1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,420,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		XG.string(10,500,"LM00="+XMath.fdouble(LM[0][0][0],3)+"+"+XMath.fdouble(LM[0][0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,520,"EV00=("+XMath.fdouble(EV[0][0][0],3)+","+XMath.fdouble(EV[0][0][1],3)+")",XColor.Color16[0],16);
		XG.string(10,540,"LM01="+XMath.fdouble(LM[0][1][0],3)+"+"+XMath.fdouble(LM[0][1][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,560,"EV01=("+XMath.fdouble(EV[0][1][0],3)+","+XMath.fdouble(EV[0][1][1],3)+")",XColor.Color16[0],16);
		XG.string(10,580,"LM10="+XMath.fdouble(LM[1][0][0],3)+"+"+XMath.fdouble(LM[1][0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,600,"EV10=("+XMath.fdouble(EV[1][0][0],3)+","+XMath.fdouble(EV[1][0][1],3)+")",XColor.Color16[0],16);
		XG.string(10,620,"LM11="+XMath.fdouble(LM[1][1][0],3)+"+"+XMath.fdouble(LM[1][1][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,640,"EV11=("+XMath.fdouble(EV[1][1][0],3)+","+XMath.fdouble(EV[1][1][1],3)+")",XColor.Color16[0],16);
		XG.string(10,660,"LM20="+XMath.fdouble(LM[2][0][0],3)+"+"+XMath.fdouble(LM[2][0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,680,"EV20=("+XMath.fdouble(EV[2][0][0],3)+","+XMath.fdouble(EV[2][0][1],3)+")",XColor.Color16[0],16);
		XG.string(10,700,"LM21="+XMath.fdouble(LM[0][1][0],3)+"+"+XMath.fdouble(LM[0][1][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,720,"EV21=("+XMath.fdouble(EV[2][1][0],3)+","+XMath.fdouble(EV[2][1][1],3)+")",XColor.Color16[0],16);
	}

	public F0201b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"2ϐWXeBbN2̌Œ_ɂŗLxNg");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0201b app=new F0201b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}