// 2ϐWXeBbNɂ镪}

package f02;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0202 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=100000,FR=300,FR2=2*FR/3,NX=12,NY=4,step=10;
	double Div=1.0E4,dt=0.05;
	double a0=0.1,a1=0.1,c0=2.0,c1=2.0;
	double r=1.0;
	double[]p0={10.0,0.001};
	double[]q0={0.001,10.0};
	double p_min=0.0,p_max=2.4;
	double u_min=-0.5,u_max=1.5;
	double Ax=(p_max-p_min)/(2*FR);
	double Bx=(p_max+p_min)/2;
	double Ay=(u_max-u_min)/(2*FR2);
	double By=(u_max+u_min)/2;

	private void setParameter(double v)
	{	c0=v;c1=v;
	}

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=a0+x[0]*(1-x[0]-c0*x[1]);
		xx[1]=a1+x[1]*(r*(1-x[1])-c1*x[0]);
		return xx;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR2+20+1,FR+20+1,-FR2-60-1,XColor.Color16[0]);

		int DX=2*FR/NX,DY=2*FR2/NY;
		for(int i=1;i<NX;i++)
			XG.line(-FR+i*DX,-FR2,-FR+i*DX,FR2,XColor.Color16[8]);
		for(int i=1;i<NY;i++)
			XG.line(-FR,-FR2+i*DY,FR,-FR2+i*DY,XColor.Color16[8]);

		for(int sx=-FR;sx<=FR;sx=sx+step)
		{	if(sx==FR/6)
			{	setParameter(setSx(sx-1));
				double[]p=p0;
				double[]q=q0;
				for(int n=0;n<NL;n++)
				{	double[]pp=rungeKutta(p,2);
					p=pp;
					double[]qq=rungeKutta(q,2);
					q=qq;
					double p2=p[0]*p[0]+p[1]*p[1];
					double q2=q[0]*q[0]+q[1]*q[1];
					if(p2>=Div||q2>=Div)
						break;
				}
				int sy=getSy(p[0]);
				if(Math.abs(sy)<=FR2)
					XG.cross(sx-1,sy,3,XColor.Color16[0],3);
				sy=getSy(q[0]);
				if(Math.abs(sy)<=FR2)
					XG.cross(sx-1,sy,3,XColor.Color16[0],3);
				setParameter(setSx(sx+2));
				p=p0;
				q=q0;
				for(int n=0;n<NL;n++)
				{	double[]pp=rungeKutta(p,2);
					p=pp;
					double[]qq=rungeKutta(q,2);
					q=qq;
					double p2=p[0]*p[0]+p[1]*p[1];
					double q2=q[0]*q[0]+q[1]*q[1];
					if(p2>=Div||q2>=Div)
						break;
				}
				sy=getSy(p[0]);
				if(Math.abs(sy)<=FR2)
					XG.cross(sx+2,sy,3,XColor.Color16[0],3);
				sy=getSy(q[0]);
				if(Math.abs(sy)<=FR2)
					XG.cross(sx+2,sy,3,XColor.Color16[0],3);
			}
			else
			{	setParameter(setSx(sx));
				double[]p=p0;
				double[]q=q0;
				for(int n=0;n<NL;n++)
				{	double[]pp=rungeKutta(p,2);
					p=pp;
					double[]qq=rungeKutta(q,2);
					q=qq;
					double p2=p[0]*p[0]+p[1]*p[1];
					double q2=q[0]*q[0]+q[1]*q[1];
					if(p2>=Div||q2>=Div)
						break;
				}
				int sy=getSy(p[0]);
				if(Math.abs(sy)<=FR2)
					XG.cross(sx,sy,3,XColor.Color16[0],3);
				sy=getSy(q[0]);
				if(Math.abs(sy)<=FR2)
					XG.cross(sx,sy,3,XColor.Color16[0],3);
			}
		}

		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR2+1,FR+1,-FR2-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR2-1,FR-1,-FR2+1,XColor.Color16[0]);

		XG.string2(FR/4-36,-FR2-52,"c  c",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(FR/4-36+32,-FR2-52,",",XColor.Color16[0],
			"Arial",Font.PLAIN,40);
		XG.string2(FR/4-36+21,-FR2-56,"0     1",XColor.Color16[0],
			"Arial",Font.PLAIN,20);
		XG.string2(-FR-9,-FR2-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR/6-22,-FR2-32,""+5*p_max/12,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(2*FR/3-22,-FR2-32,""+5*p_max/6,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y+11,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR2/2-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR2/2-12,""+2*u_max/3,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a0="+a0,XColor.Color16[0],16);
		XG.string(10,160,"a1="+a1,XColor.Color16[0],16);
		XG.string(10,180,"c0="+c0,XColor.Color16[0],16);
		XG.string(10,200,"c1="+c1,XColor.Color16[0],16);
		XG.string(10,220,"r="+r,XColor.Color16[0],16);
		XG.string(10,300,"p0=("+p0[0]+","+p0[1]+")",XColor.Color16[0],16);
		XG.string(10,320,"q0=("+q0[0]+","+q0[1]+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"p="+p_min+"<<"+p_max,XColor.Color16[0],16);
		XG.string(10,460,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0202()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"2ϐWXeBbNɂ镪}");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0202 app=new F0202();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}