// Scheffer̍ŏ2fɂŒ_ւ̎

package f02;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0203b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=100000,FR=200,n=4;
	double Div=1.0E4,dt=0.01,step=2.0*FR/n;
	double h=0.3,r=1.4,m=0.8;
	double[]p0={0.6,0.6};
	double[]FP=new double[2];
	double[][]LM=new double[2][2];
	double[]EV=new double[2];
	double u_min=0.0,u_max=0.8;
	double v_min=0.0,v_max=0.8;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		double f=x[0]/(h+x[0]);
		xx[0]=x[0]*(1-x[0])-f*x[1];
		xx[1]=(r*f-m)*x[1];
		return xx;
	}

	private double[]getFP()
	{	double[]fp=new double[2];
		fp[0]=m*h/(r-m);
		fp[1]=r*h*(r-m-m*h)/((r-m)*(r-m));
		return fp;
	}

	private double[][]getLM()
	{	double[][]e=new double[2][2];
		double k1=-(1-2*FP[0]-h/((h+FP[0])*(h+FP[0]))*FP[1]+r*FP[0]/(h+FP[0])-m);
		double k0=(1-2*FP[0])*(r*FP[0]/(h+FP[0])-m)+m*h/((h+FP[0])*(h+FP[0]))*FP[1];
		e=XAlgebra.roots2dEq(k1,k0);
		return e;
	}

	private double[]getEV()
	{	double[]v=new double[2];
		double A00=1-2*FP[0]-h/((h+FP[0])*(h+FP[0]))*FP[1];
		double A01=-FP[0]/(h+FP[0]);
		v[0]=-(A00-LM[0][0])*A01/((A00-LM[0][0])*(A00-LM[0][0])+LM[0][1]*LM[0][1]);
		v[1]=-LM[0][1]*A01/((A00-LM[0][0])*(A00-LM[0][0])+LM[0][1]*LM[0][1]);
		return v;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		FP=getFP();
		LM=getLM();
		EV=getEV();

		double[]p=new double[2];
		for(int sx=-FR;sx<=FR;sx++)
		{	p[0]=setSx(sx);
			for(int sy=-FR;sy<=FR;sy++)
			{	p[1]=setSy(sy);
				double[]pp=diff(p,2);
				if(pp[0]>=0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[1]);
				if(pp[0]>=0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[2]);
				if(pp[0]<0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[6]);
				if(pp[0]<0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[4]);
			}
		}

		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(i*step),-FR,-FR+XMath.fint(i*step),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(i*step),FR,-FR+XMath.fint(i*step),XColor.Color16[8]);

		p[0]=p0[0]-FP[0];
		p[1]=p0[1]-FP[1];
		double c0=p[1];
		double c1=(p[0]-c0*EV[0])/EV[1];
		Point sp_=new Point(getSx(p[0]+FP[0]),getSy(p[1]+FP[1]));
		XG.plus(sp_,4,XColor.Color16[0],3);
		for(int n=0;n<NL;n++)
		{	double t=n*dt;
			double E=Math.exp(LM[0][0]*t);
			double C=Math.cos(LM[0][1]*t);
			double S=Math.sin(LM[0][1]*t);
			p[0]=E*(c0*(EV[0]*C-EV[1]*S)+c1*(EV[0]*S+EV[1]*C));
			p[1]=E*(c0*C+c1*S);
			double p2=p[0]*p[0]+p[1]*p[1];
			if(p2>=Div)
				break;
			Point sp=new Point(getSx(p[0]+FP[0]),getSy(p[1]+FP[1]));
			if(n!=0)
			{	if(Math.abs(sp_.x)<=FR&&Math.abs(sp_.y)<=FR
					&&Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR)
					XG.line(sp_,sp,XColor.Color16[0],1);
			}
			sp_=sp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(getSx(FP[0])-22,getSy(FP[1])+4,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string2(-FR+12,FR-40,"(b)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-9,-FR-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-23,-FR-32,""+u_max/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-26,-FR-32,""+u_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,""+v_max/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		int xx=112,yy=192;
		XG.rectangleF(xx,yy,xx+76,yy-124,XColor.Color16[7]);
		XG.rectangleF(xx+8,yy-6,xx+38,yy-28,XColor.Color16[1]);
		XG.arrow(xx+48,yy-29,xx+68,yy-9,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-36,xx+38,yy-58,XColor.Color16[2]);
		XG.arrow(xx+48,yy-39,xx+68,yy-59,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-66,xx+38,yy-88,XColor.Color16[6]);
		XG.arrow(xx+68,yy-69,xx+48,yy-89,XColor.Color16[0],1,16);
		XG.rectangleF(xx+8,yy-96,xx+38,yy-118,XColor.Color16[4]);
		XG.arrow(xx+68,yy-119,xx+48,yy-99,XColor.Color16[0],1,16);

		XG.string(10,140,"h="+h,XColor.Color16[0],16);
		XG.string(10,160,"r="+r,XColor.Color16[0],16);
		XG.string(10,180,"m="+m,XColor.Color16[0],16);
		XG.string(10,200,"p0=("+XMath.fdouble(p0[0],3)+","
			+XMath.fdouble(p0[1],3)+")",XColor.Color16[0],16);
		XG.string(10,300,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		XG.string(10,500,"LM0="+XMath.fdouble(LM[0][0],3)+"+"+XMath.fdouble(LM[0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,520,"LM1="+XMath.fdouble(LM[1][0],3)+"+"+XMath.fdouble(LM[1][1],3)+"i",XColor.Color16[0],16);
	}

	public F0203b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"Scheffer̍ŏ2fɂŒ_ւ̎");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0203b app=new F0203b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}