// 3ϐΏԌnfɂ镪}

package f02;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0208 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=20000,FR=300,FR2=2*FR/3,NX=10,NY=4;
	double Div=1.0E4,dt=0.01;
	double a1=0.6,b1=1.2,c1=2.0;
	double a2=0.2,b2=2.0,c2=0.2;
	double h0=0.04,h1=4.0,h2=0.5;
	double[]p0={1.0,2.0,8.0};
	double p_min=0.0,p_max=5.0;
	double u_min=0.0,u_max=4.0;
	double Ax=(p_max-p_min)/(2*FR);
	double Bx=(p_max+p_min)/2;
	double Ay=(u_max-u_min)/(2*FR2);
	double By=(u_max+u_min)/2;

	private void setParameter(double v)
	{	b2=v;
	}

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		double f0=x[0]/(h0+x[0]);
		double f1=x[1]/(h1+x[1]);
		double f2=x[2]/(h2+x[2]);
		xx[0]=1-f0*x[1]+f2*x[0];
		xx[1]=a1-b1*f1*x[2]+c1*f0*x[1];
		xx[2]=a2-b2*f2*x[0]+c2*f1*x[2];
		return xx;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR2+20+1,FR+20+1,-FR2-60-1,XColor.Color16[0]);

		int DX=2*FR/NX,DY=2*FR2/NY;
		for(int i=1;i<NX;i++)
			XG.line(-FR+i*DX,-FR2,-FR+i*DX,FR2,XColor.Color16[8]);
		for(int i=1;i<NY;i++)
			XG.line(-FR,-FR2+i*DY,FR,-FR2+i*DY,XColor.Color16[8]);

		for(int sx=-FR;sx<=FR;sx++)
		{	setParameter(setSx(sx));
			double[]p=p0;
			for(int n=0;n<NL;n++)
			{	double[]pp=rungeKutta(p,3);
				p=pp;
				double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
				if(p2>=Div)
					break;
				int sy=getSy(p[0]);
				if(n>4*NL/5&&Math.abs(sy)<=FR2)
					XG.pixel(sx,sy,XColor.Color16[0]);
			}
		}

		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR2+1,FR+1,-FR2-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR2-1,FR-1,-FR2+1,XColor.Color16[0]);

		XG.string2(FR/2-11,-FR2-52,"p",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-9,-FR2-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-22,-FR2-32,""+p_max/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-27,-FR2-32,""+p_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR2/2+11,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR2-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,""+(u_min+u_max)/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR2-12,""+u_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a1="+a1,XColor.Color16[0],16);
		XG.string(10,160,"b1="+b1,XColor.Color16[0],16);
		XG.string(10,180,"c1="+c1,XColor.Color16[0],16);
		XG.string(10,200,"a2="+a2,XColor.Color16[0],16);
		XG.string(10,220,"b2="+b2,XColor.Color16[0],16);
		XG.string(10,240,"c2="+c2,XColor.Color16[0],16);
		XG.string(10,260,"h0="+h0,XColor.Color16[0],16);
		XG.string(10,280,"h1="+h1,XColor.Color16[0],16);
		XG.string(10,300,"h2="+h2,XColor.Color16[0],16);
		XG.string(10,340,"p0=("+p0[0]+","+p0[1]+","+p0[2]+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"p="+p_min+"<<"+p_max,XColor.Color16[0],16);
		XG.string(10,460,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0208()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"3ϐΏԌnfɂ镪}");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0208 app=new F0208();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}