// 3ϐΏԌnfɂXgWAgN^

package f02;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0209a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=200000,FR=200,n=4;
	double Div=1.0E4,dt=0.01;
	double a1=0.6,b1=1.2,c1=2.0;
	double a2=0.2,b2=2.0,c2=0.2;
	double h0=0.04,h1=4.0,h2=0.5;
	double[]p0={1.0,2.0,8.0};
	double[][]FP=new double[2][3];
	double[][][]LM=new double[2][3][2];
	double u_min=0.0,u_max=4.0;
	double v_min=0.0,v_max=16.0;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		double f0=x[0]/(h0+x[0]);
		double f1=x[1]/(h1+x[1]);
		double f2=x[2]/(h2+x[2]);
		xx[0]=1-f0*x[1]+f2*x[0];
		xx[1]=a1-b1*f1*x[2]+c1*f0*x[1];
		xx[2]=a2-b2*f2*x[0]+c2*f1*x[2];
		return xx;
	}

	private double[][]getFP(int n)
	{	double[][]fp=new double[2][n];
		double A2=((a1+c1)*c2+a2*b1)/(b1*b2-c1*c2);
		double A0=1+A2;
		double A1=(a1+c1*A0)/b1;
		double k2=A1*(A0+h1);
		double k1=A0*A1*h0-A0*A2*h2-A1*A2*(A0+h1);
		double k0=-A0*A2*h0*(A1+h2);
		double[][]x=new double[2][2];
		x=XAlgebra.roots2dEq(k1/k2,k0/k2);
		fp[0][0]=x[0][0];
		fp[0][1]=A0*(h0+fp[0][0])/fp[0][0];
		fp[0][2]=A1*(h1+fp[0][1])/fp[0][1];
		fp[1][0]=x[1][0];
		fp[1][1]=A0*(h0+fp[1][0])/fp[1][0];
		fp[1][2]=A1*(h1+fp[1][1])/fp[1][1];
		return fp;
	}

	private double[][][]getLM()
	{	double[][][]lm=new double[2][3][2];
		double[][]A=new double[3][3];
		for(int i=0;i<2;i++)
		{	A[0][0]=-h0*FP[i][1]/((h0+FP[i][0])*(h0+FP[i][0]))+FP[i][2]/(h2+FP[i][2]);
			A[0][1]=-FP[i][0]/(h0+FP[i][0]);
			A[0][2]=h2*FP[i][0]/((h2+FP[i][2])*(h2+FP[i][2]));
			A[1][1]=-b1*h1*FP[i][2]/((h1+FP[i][1])*(h1+FP[i][1]))+c1*FP[i][0]/(h0+FP[i][0]);
			A[1][2]=-b1*FP[i][1]/(h1+FP[i][1]);
			A[1][0]=c1*h0*FP[i][1]/((h0+FP[i][0])*(h0+FP[i][0]));
			A[2][2]=-b2*h2*FP[i][0]/((h2+FP[i][2])*(h2+FP[i][2]))+c2*FP[i][1]/(h1+FP[i][1]);
			A[2][0]=-b2*FP[i][2]/(h2+FP[i][2]);
			A[2][1]=c2*h1*FP[i][2]/((h1+FP[i][1])*(h1+FP[i][1]));
			lm[i]=XAlgebra.eigenValues33Mr(A);
		}
		return lm;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		FP=getFP(3);
		LM=getLM();

		double D=2.0*FR/n;
		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(D*i),-FR,-FR+XMath.fint(D*i),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(D*i),FR,-FR+XMath.fint(D*i),XColor.Color16[8]);

		double[]p=p0;
		Point sp_=new Point(getSx(p[0]),getSy(p[1]));
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,3);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
			if(p2>=Div)
				break;
			Point sp=new Point(getSx(p[0]),getSy(p[1]));
			if(Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR)
				XG.line(sp_,sp,XColor.Color16[0]);
			sp_=sp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.cross(getSx(FP[0][0]),getSy(FP[0][1]),3,XColor.Color16[0],3);

		XG.string2(getSx(FP[0][0])-24,getSy(FP[0][1])-8,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string2(FR-58,FR-40,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-9,-FR-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-23,-FR-32,""+u_max/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-26,-FR-32,""+u_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,""+v_max/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-68,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a1="+a1,XColor.Color16[0],16);
		XG.string(10,160,"b1="+b1,XColor.Color16[0],16);
		XG.string(10,180,"c1="+c1,XColor.Color16[0],16);
		XG.string(10,200,"a2="+a2,XColor.Color16[0],16);
		XG.string(10,220,"b2="+b2,XColor.Color16[0],16);
		XG.string(10,240,"c2="+c2,XColor.Color16[0],16);
		XG.string(10,260,"h0="+h0,XColor.Color16[0],16);
		XG.string(10,280,"h1="+h1,XColor.Color16[0],16);
		XG.string(10,300,"h2="+h2,XColor.Color16[0],16);
		XG.string(10,320,"p0=("+p0[0]+","+p0[1]+","+p0[2]+")",XColor.Color16[0],16);
		XG.string(10,340,"FP0=("+XMath.fdouble(FP[0][0],3)+","+XMath.fdouble(FP[0][1],3)+","
			+XMath.fdouble(FP[0][2],3)+")",XColor.Color16[0],16);
		XG.string(10,360,"FP1=("+XMath.fdouble(FP[1][0],3)+","+XMath.fdouble(FP[1][1],3)+","
			+XMath.fdouble(FP[1][2],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		XG.string(10,500,"LM00="+XMath.fdouble(LM[0][0][0],3)+"+"+XMath.fdouble(LM[0][0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,520,"LM01="+XMath.fdouble(LM[0][1][0],3)+"+"+XMath.fdouble(LM[0][1][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,540,"LM02="+XMath.fdouble(LM[0][2][0],3)+"+"+XMath.fdouble(LM[0][2][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,560,"LM10="+XMath.fdouble(LM[1][0][0],3)+"+"+XMath.fdouble(LM[1][0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,580,"LM11="+XMath.fdouble(LM[1][1][0],3)+"+"+XMath.fdouble(LM[1][1][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,600,"LM12="+XMath.fdouble(LM[1][2][0],3)+"+"+XMath.fdouble(LM[1][2][1],3)+"i",XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0209a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"3ϐΏԌnfɂXgWAgN^");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0209a app=new F0209a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}