// 2dUq̃Aj[V

package f03;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class A0302 extends XFrame implements Runnable,ActionListener
{	String[]file={"Start","Reset","Exit"};
	JButton[]bt=new JButton[file.length];
	Thread th=null;
	XGraphics XG;
	int Y0=140,k=180,flag=0;
	double dt=0.04;
	double L=1.0/Math.sqrt(2.0),M=0.6,g=1.0;
	double T1=90.0,T2=90.0,A1=0.0,A2=0.0;
	double t1=T1*Math.PI/180.0,t2=T2*Math.PI/180.0;
	double a1=A1*Math.PI/180.0,a2=A2*Math.PI/180.0;
	double[]p0={t1,t2,a1,a2};
	double[]p=p0;
	int x1=0,y1=0,x2=0,y2=0;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[2];
		xx[1]=x[3];
		double f1=-M*L*x[3]*x[3]*Math.sin(x[0]-x[1])-g*Math.sin(x[0]);
		double f2=(x[2]*x[2]*Math.sin(x[0]-x[1])-g*Math.sin(x[1]))/L;
		double det=1.0-M*Math.cos(x[0]-x[1])*Math.cos(x[0]-x[1]);
		xx[2]=(f1-M*L*Math.cos(x[0]-x[1])*f2)/det;
		xx[3]=(-Math.cos(x[0]-x[1])/L*f1+f2)/det;
		return xx;
	}

	private void myPaint()
	{	double[]pp=rungeKutta(p,4);
		p=pp;
		if(flag!=0)
		{	XG.line(0,0,x1,y1,XColor.Color16[7],2);
			XG.line(x1,y1,x2,y2,XColor.Color16[7],2);
			XG.disk(0,0,4,XColor.Color16[0]);
			XG.disk(x1,y1,4,XColor.Color16[0]);
			XG.disk(x2,y2,4,XColor.Color16[0]);
		}
		double x_1=k*Math.sin(p[0]);
		double y_1=k*Math.cos(p[0]);
		double x_2=k*(Math.sin(p[0])+L*Math.sin(p[1]));
		double y_2=k*(Math.cos(p[0])+L*Math.cos(p[1]));

		int xx1=XMath.fint(x_1);
		int yy1=XMath.fint(y_1);
		int xx2=XMath.fint(x_2);
		int yy2=XMath.fint(y_2);

		XG.line(0,0,xx1,yy1,XColor.Color16[0],2);
		XG.line(xx1,yy1,xx2,yy2,XColor.Color16[0],2);
		XG.disk(0,0,4,XColor.Color16[0]);
		XG.disk(xx1,yy1,4,XColor.Color16[0]);
		XG.disk(xx2,yy2,4,XColor.Color16[0]);

		x1=xx1;y1=yy1;x2=xx2;y2=yy2;flag=1;
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public void run()
	{	Thread th0=Thread.currentThread();
		while(th==th0)
		{	myPaint();
			try
			{	Thread.sleep(50);
			}
			catch(InterruptedException e){}
		}
	}

	public A0302()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"2dUq̃Aj[V");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
		XG.set0(FC.x,FC.y-Y0,0);
	}

	public static void main(String[]argv)
	{   A0302 app=new A0302();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
		{	if(th==null)
			{	th=new Thread(this);
				th.start();
			}
		}
		if(evt.getSource()==bt[1])
		{	repaint();
			th=null;
			flag=0;
			p0[0]=t1;p0[1]=t2;p0[2]=a1;p0[3]=a2;
			p=p0;
		}
		if(evt.getSource()==bt[2])
		{	th=null;
			dispose();
			System.exit(0);
		}
	}
}