// ΂ːUq̃Aj[V

package f03;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class A0303 extends XFrame implements Runnable,ActionListener
{	String[]file={"Start","Reset","Exit"};
	JButton[]bt=new JButton[file.length];
	Thread th=null;
	XGraphics XG;
	int Y0=20,L=150,flag=0;
	double dt=0.02;
	double k=160.0,g=9.8;
	double x=0.8,v=0.0,T=90.0,A=0.0;
	double t=T*Math.PI/180.0,a=A*Math.PI/180.0;
	double[]p0={x,t,v,a};
	double[]p=p0;
	int x1=0,y1=0;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[2];
		xx[1]=x[3];
		xx[2]=(1+x[0])*x[3]*x[3]-g*(1-Math.cos(x[1]))-k*x[0];
		xx[3]=-(2*x[2]*x[3]+g*Math.sin(x[1]))/(1+x[0]);
		return xx;
	}

	private void myPaint()
	{	double[]pp=rungeKutta(p,4);
		p=pp;
		if(flag!=0)
		{	XG.line(0,0,x1,y1,XColor.Color16[7],2);
			XG.disk(0,0,4,XColor.Color16[0]);
			XG.disk(x1,y1,4,XColor.Color16[0]);
		}
		double x_1=L*(1+p[0])*Math.sin(p[1]);
		double y_1=L*(1+p[0])*Math.cos(p[1]);

		int xx1=XMath.fint(x_1);
		int yy1=XMath.fint(y_1);

		XG.line(0,0,xx1,yy1,XColor.Color16[0],2);
		XG.disk(0,0,4,XColor.Color16[0]);
		XG.disk(xx1,yy1,4,XColor.Color16[0]);

		x1=xx1;y1=yy1;flag=1;
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public void run()
	{	Thread th0=Thread.currentThread();
		while(th==th0)
		{	myPaint();
			try
			{	Thread.sleep(50);
			}
			catch(InterruptedException e){}
		}
	}

	public A0303()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"΂ːUq̃Aj[V");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
		XG.set0(FC.x,FC.y-Y0,0);
	}

	public static void main(String[]argv)
	{   A0303 app=new A0303();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
		{	if(th==null)
			{	th=new Thread(this);
				th.start();
			}
		}
		if(evt.getSource()==bt[1])
		{	repaint();
			th=null;
			flag=0;
			p0[0]=x;p0[1]=t;p0[2]=v;p0[3]=a;
			p=p0;
		}
		if(evt.getSource()==bt[2])
		{	th=null;
			dispose();
			System.exit(0);
		}
	}
}