// 2dUqɂJIX

package f03;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import xxx.*;

public class F0302b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=500,FR=340,FR2=200,Y0=140,k=180;
	double Div=1.0E10,dt=0.04;
	double L=1.0/Math.sqrt(2.0),M=0.6,g=1.0;
	double T1=90.0,T2=90.0,A1=0.0,A2=0.0;
	double t1=T1*Math.PI/180.0,t2=T2*Math.PI/180.0;
	double a1=A1*Math.PI/180.0,a2=A2*Math.PI/180.0;
	double[]p0={t1,t2,a1,a2};

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[2];
		xx[1]=x[3];
		double f1=-M*L*x[3]*x[3]*Math.sin(x[0]-x[1])-g*Math.sin(x[0]);
		double f2=(x[2]*x[2]*Math.sin(x[0]-x[1])-g*Math.sin(x[1]))/L;
		double det=1.0-M*Math.cos(x[0]-x[1])*Math.cos(x[0]-x[1]);
		xx[2]=(f1-M*L*Math.cos(x[0]-x[1])*f2)/det;
		xx[3]=(-Math.cos(x[0]-x[1])/L*f1+f2)/det;
		return xx;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-20-1,FR2+20+1,FR+20+1,-FR2-20-1,XColor.Color16[0]);
		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);

		XG.set0(FC.x,FC.y-Y0,0);

		double[]p=p0;
		int x1=0,y1=0,x2=0,y2=0;
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,4);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2]+p[3]*p[3];
			if(p2>=Div)
			{	XG.string(80,90,"Divergence!",XColor.Color16[0],16);
				break;
			}
			if(n!=0)
			{	XG.line(0,0,x1,y1,XColor.Color16[7],2);
				XG.line(x1,y1,x2,y2,XColor.Color16[7],2);
				XG.disk(0,0,4,XColor.Color16[0]);
				XG.disk(x1,y1,4,XColor.Color16[0]);
				XG.disk(x2,y2,4,XColor.Color16[0]);
			}
			double x_1=k*Math.sin(p[0]);
			double y_1=k*Math.cos(p[0]);
			double x_2=k*(Math.sin(p[0])+L*Math.sin(p[1]));
			double y_2=k*(Math.cos(p[0])+L*Math.cos(p[1]));

			int xx1=XMath.fint(x_1);
			int yy1=XMath.fint(y_1);
			int xx2=XMath.fint(x_2);
			int yy2=XMath.fint(y_2);

			XG.line(0,0,xx1,yy1,XColor.Color16[0],2);
			XG.line(xx1,yy1,xx2,yy2,XColor.Color16[0],2);
			XG.disk(0,0,4,XColor.Color16[0]);
			XG.disk(xx1,yy1,4,XColor.Color16[0]);
			XG.disk(xx2,yy2,4,XColor.Color16[0]);

			x1=xx1;y1=yy1;x2=xx2;y2=yy2;
		}	

		XG.string(10,140,"L="+XMath.fdouble(L,3),XColor.Color16[0],16);
		XG.string(10,160,"M="+M,XColor.Color16[0],16);
		XG.string(10,180,"k="+k,XColor.Color16[0],16);
		XG.string(10,200,"T1="+T1,XColor.Color16[0],16);
		XG.string(10,220,"T2="+T2,XColor.Color16[0],16);
		XG.string(10,240,"A1="+A1,XColor.Color16[0],16);
		XG.string(10,260,"A2="+A2,XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"t="+0+"<<"+XMath.fint(NL*dt),XColor.Color16[0],16);
		XG.string(10,700,"p0=("+XMath.fdouble(p0[0],3)+","+XMath.fdouble(p0[1],3)+","
			+XMath.fdouble(p0[2],3)+","+XMath.fdouble(p0[3],3)+")",XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0302b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"2dUqɂJIX");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{   F0302b app=new F0302b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}
}