// ΂ːUqɂJIX

package f03;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import xxx.*;

public class F0303b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=500,FR=300,FR2=300,Y0=20,L=150;
	double Div=1.0E10,dt=0.02;
	double k=160.0,g=9.8;
	double x=0.8,v=0.0,T=90.0,A=0.0;
	double t=T*Math.PI/180.0,a=A*Math.PI/180.0;
	double[]p0={x,t,v,a};

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[2];
		xx[1]=x[3];
		xx[2]=(1+x[0])*x[3]*x[3]-g*(1-Math.cos(x[1]))-k*x[0];
		xx[3]=-(2*x[2]*x[3]+g*Math.sin(x[1]))/(1+x[0]);
		return xx;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-20-1,FR2+20+1,FR+20+1,-FR2-20-1,XColor.Color16[0]);
		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);

		XG.set0(FC.x,FC.y-Y0,0);

		double[]p=p0;
		int x1=0,y1=0;
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,4);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2]+p[3]*p[3];
			if(p2>=Div)
			{	XG.string(80,90,"Divergence!",XColor.Color16[0],16);
				break;
			}
			if(n!=0)
			{	XG.line(0,0,x1,y1,XColor.Color16[7],2);
				XG.disk(0,0,4,XColor.Color16[0]);
				XG.disk(x1,y1,4,XColor.Color16[0]);
			}
			double x_1=L*(1+p[0])*Math.sin(p[1]);
			double y_1=L*(1+p[0])*Math.cos(p[1]);

			int xx1=XMath.fint(x_1);
			int yy1=XMath.fint(y_1);

			XG.line(0,0,xx1,yy1,XColor.Color16[0],2);
			XG.disk(0,0,4,XColor.Color16[0]);
			XG.disk(xx1,yy1,4,XColor.Color16[0]);

			x1=xx1;y1=yy1;
		}	

		XG.string(10,140,"L="+L,XColor.Color16[0],16);
		XG.string(10,160,"k="+k,XColor.Color16[0],16);
		XG.string(10,180,"g="+g,XColor.Color16[0],16);
		XG.string(10,200,"x="+XMath.fdouble(x,3),XColor.Color16[0],16);
		XG.string(10,220,"v="+XMath.fdouble(v,3),XColor.Color16[0],16);
		XG.string(10,240,"T="+T,XColor.Color16[0],16);
		XG.string(10,260,"A="+A,XColor.Color16[0],16);
		XG.string(10,300,"p0=("+XMath.fdouble(p0[0],3)+","+XMath.fdouble(p0[1],3)+","
			+XMath.fdouble(p0[2],3)+","+XMath.fdouble(p0[3],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"t="+0+"<<"+XMath.fint(NL*dt),XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0303b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"΂ːUqɂJIX");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{   F0303b app=new F0303b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}
}