// Pꂽ3̖ɂJIX

package f03;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0304 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=400000,FR=200,n=5;
	double Div=1.0E10,dt=0.0001;
	double[]p0={0.5,0.15,0.0,0.0};
	double k=4.0,m1=k/(k+1),m2=1.0/(k+1);
	double x_min=-0.8,x_max=1.2;
	double y_min=-1.0,y_max=1.0;
	double Ax=(x_max-x_min)/(2*FR);
	double Bx=(x_max+x_min)/2;
	double Ay=(y_max-y_min)/(2*FR);
	double By=(y_max+y_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		double r1=Math.sqrt((x[0]+m2)*(x[0]+m2)+x[1]*x[1]);
		double r2=Math.sqrt((x[0]-m1)*(x[0]-m1)+x[1]*x[1]);
		double r13=r1*r1*r1;
		double r23=r2*r2*r2;
		xx[0]=x[2];
		xx[1]=x[3];
		xx[2]=x[0]+2*x[3]-m1*x[0]/r13-m2*x[0]/r23-m1*m2/r13+m1*m2/r23;
		xx[3]=x[1]-2*x[2]-m1*x[1]/r13-m2*x[1]/r23;
		return xx;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double D=2*(double)FR/n;
		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(i*D),-FR,-FR+XMath.fint(i*D),FR,XColor.Color16[8]);
		for(int i=0;i<n;i++)
			XG.line(-FR,-FR+XMath.fint((i+0.5)*D),FR,-FR+XMath.fint((i+0.5)*D),XColor.Color16[8]);

		double[]p=p0;
		Point sp_=new Point(getSx(p[0]),getSy(p[1]));
		XG.plus(sp_,4,XColor.Color16[0],3);
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,4);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2]+p[3]*p[3];
			if(p2>=Div)
			{	XG.string(80,90,"Divergence!",XColor.Color16[0],16);
				break;
			}
			Point sp=new Point(getSx(p[0]),getSy(p[1]));
			if(n!=0&&Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR
				&&Math.abs(sp_.x)<=FR&&Math.abs(sp_.y)<=FR)
				XG.line(sp_,sp,XColor.Color16[0]);
			sp_=sp;
		}
		XG.disk(sp_,4,XColor.Color16[0]);

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.disk(getSx(m1),0,2,XColor.Color16[0]);
		XG.disk(getSx(-m2),0,7,XColor.Color16[0]);

		XG.string2(FR/5-11,-FR-52,"x",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-34,-FR-32,""+x_min,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR/5-9,-FR-32,""+XMath.fint((3*x_min+2*x_max)/5),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(3*FR/5-23,-FR-32,""+XMath.fdouble((x_min+4*x_max)/5,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-27,-FR-32,""+x_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-2*FR/5+11,"y",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-61,-4*FR/5-12,""+XMath.fdouble((9*y_min+y_max)/10,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-12,""+XMath.fint((y_min+y_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,4*FR/5-12,""+XMath.fdouble((y_min+9*y_max)/10,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"k="+k,XColor.Color16[0],16);
		XG.string(10,160,"m1="+m1,XColor.Color16[0],16);
		XG.string(10,180,"m2="+m2,XColor.Color16[0],16);
		XG.string(10,200,"p0=("+p0[0]+","+p0[1]+","+p0[2]+","+p0[3]+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"x="+x_min+"<<"+x_max,XColor.Color16[0],16);
		XG.string(10,460,"y="+y_min+"<<"+y_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0304()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"Pꂽ3̖ɂJIX");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{   F0304 app=new F0304();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}