// Henon-Heilesn|AJʑ

package f03;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0305b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=100000000,FR=200,n=6;
	double Div=1.0E6,dt=0.01,step=0.01;
	double H=1.0/8;
	double[]p0={Math.sqrt(2*H),0.0,0.0,0.0};
	double y_min=-0.5,y_max=0.7;
	double v_min=-0.6,v_max=0.6;
	double Ax=(y_max-y_min)/(2*FR);
	double Bx=(y_max+y_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[2];
		xx[1]=x[3];
		xx[2]=-x[0]-2*x[0]*x[1];
		xx[3]=-x[1]-x[0]*x[0]+x[1]*x[1];
		return xx;
	}

	private double curve(double y)
	{	return 2*H-y*y+2*y*y*y/3;
	}

	private void myPaint()
	{	XTimer tm=new XTimer();
		tm.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double D=2*(double)FR/n;
		for(int i=0;i<n;i++)
			XG.line(-FR+XMath.fint((i+0.5)*D),-FR,-FR+XMath.fint((i+0.5)*D),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(i*D),FR,-FR+XMath.fint(i*D),XColor.Color16[8]);

		int sx_=0,sy_=0;
		for(int sx=-FR;sx<=FR;sx++)
		{	int sy=0;
			double y=curve(setSx(sx));
			if(y>=0)
			{	sy=getSy(Math.sqrt(y));
				if(Math.abs(sy)<=FR&&Math.abs(sy_)<=FR)
				{	XG.line(sx_,sy_,sx,sy,XColor.Color16[0]);
					XG.line(sx_,-sy_,sx,-sy,XColor.Color16[0]);
				}
			}
			else
				if(sy_>0)
				{	XG.line(sx_,sy_,sx,0,XColor.Color16[0]);
					XG.line(sx_,-sy_,sx,0,XColor.Color16[0]);
				}
			sx_=sx;sy_=sy;
		}

		double[]p=p0;
		double[]p_=p0;
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,4);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2]+p[3]*p[3];
			if(p2>=Div)
				break;
			if(p_[0]*p[0]<0)
			{	int sx=getSx((p_[1]+p[1])/2);
				int sy=getSy((p_[3]+p[3])/2);
				if(n>NL/10000&&Math.abs(sx)<=FR&&Math.abs(sy)<=FR)
					XG.pixel(sx,sy,XColor.Color16[0]);
			}
			p_=p;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(FR-58,FR-40,"(b)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(FR/6-11,-FR-48,"y",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-5*FR/6-34,-FR-32,""+XMath.fdouble((11*y_min+y_max)/12,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR/6-9,-FR-32,""+XMath.fint((7*y_min+5*y_max)/12),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR/2-23,-FR-32,""+XMath.fdouble((y_min+3*y_max)/4,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(5*FR/6-22,-FR-32,""+XMath.fdouble((y_min+11*y_max)/12,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-61,-FR-12,""+v_min,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-12,""+XMath.fint((v_min+v_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"H="+XMath.fdouble(H,3),XColor.Color16[0],16);
		XG.string(10,200,"p0=("+XMath.fdouble(p0[0],3)+","+p0[1]+","+p0[2]+","+p0[3]+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"y="+y_min+"<<"+y_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		tm.getTimer();
		XG.string(10,720,"Time="+tm.Time,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0305b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"Henon-Heilesnɂ|AJʑ");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0305b app=new F0305b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}