// KEXz֐̊gU

package f04;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0401b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	double Div=1.0E4;
	int FR=300,FR2=2*FR/3,NX=20,NY=6;
	int N=300;
	int NL=5000,Dn=NL/5;
	double dt=0.1;
	double k=1.0,a=5.0,d=1.0;
	double x_min=-100.0,x_max=100.0;
	double dx=(x_max-x_min)/N;
	double u_min=0.0,u_max=1.2;
	double Ax=(x_max-x_min)/(2*FR);
	double Bx=(x_max+x_min)/2;
	double Ay=(u_max-u_min)/(2*FR2);
	double By=(u_max+u_min)/2;

	private double curveU(double x)
	{	return k*Math.exp(-(x/a)*(x/a));
	}

	private double[]initU()
	{	double[]u=new double[N+1];
		for(int n=0;n<=N;n++)
		{	double x=getX(n);
			u[n]=curveU(x);
		}
		return u;
	}

	private double diff(double u,double ux,double uxx)
	{	return d*uxx;
	}

	private void myPaint()
	{	XColor.setShdSpectra(0,7);
		XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR2+20+1,FR+20+1,-FR2-60-1,XColor.Color16[0]);

		int DX=2*FR/NX;
		double DY=2*(double)FR2/NY;
		for(int i=0;i<NX;i++)
			XG.line(-FR+(i+1)*DX,-FR2,-FR+(i+1)*DX,FR2,XColor.Color16[8]);
		for(int i=0;i<NY;i++)
			XG.line(-FR,-FR2+XMath.fint((i+1)*DY),FR,-FR2+XMath.fint((i+1)*DY),
				XColor.Color16[8]);

		double[][]w=new double[3][N+1];
		double[][]ww=new double[3][N+1];
		double[]u_ini=new double[N+1];
		u_ini=initU();
		for(int n=0;n<=N;n++)
			ww[0][n]=u_ini[n];
		w=pDiff(ww[0],N,dx);
		draw(w[0],0);

		for(int n=1;n<=NL;n++)
		{	ww=rungeKutta(w);
			w=ww;
			if(n%Dn==0)
				draw(w[0],n);
		}

		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR2+1,FR+1,-FR2-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR2-1,FR-1,-FR2+1,XColor.Color16[0]);

		XG.string2(FR/2-9,-FR2-52,"x",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-37,-FR2-32,"-100",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-9,-FR2-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-35,-FR2-32,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y+FR2/5+11,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-25,-FR2-6,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-52,2*FR2/3-12,"1.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string2(-FR+10,FR2-40,"(b)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string(10,160,"k="+k,XColor.Color16[0],16);
		XG.string(10,180,"a="+a,XColor.Color16[0],16);
		XG.string(10,200,"d="+d,XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"TL="+NL*dt,XColor.Color16[0],16);
		XG.string(10,460,"N="+N,XColor.Color16[0],16);
		XG.string(10,500,"x="+x_min+"<<"+x_max,XColor.Color16[0],16);
		XG.string(10,520,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,540,"Dn="+Dn,XColor.Color16[0],16);
	}

	private double[][]rungeKutta(double[][]w)
	{	double[][]ww=new double[3][N+1];
		double[][]w_=new double[3][N+1];
		double[]x1=new double[N+1];
		double[]x2=new double[N+1];
		double[]x3=new double[N+1];
		double[]x4=new double[N+1];
		for(int n=0;n<=N;n++)
		{	x1[n]=diff(w[0][n],w[1][n],w[2][n]);
			w_[0][n]=w[0][n]+x1[n]/2*dt;
		}
		ww=pDiff(w_[0],N,dx);
		for(int n=0;n<=N;n++)
		{	x2[n]=diff(ww[0][n],ww[1][n],ww[2][n]);
			w_[0][n]=w[0][n]+x2[n]/2*dt;
		}
		ww=pDiff(w_[0],N,dx);
		for(int n=0;n<=N;n++)
		{	x3[n]=diff(ww[0][n],ww[1][n],ww[2][n]);
			w_[0][n]=w[0][n]+x3[n]*dt;
		}
		ww=pDiff(w_[0],N,dx);
		for(int n=0;n<=N;n++)
			x4[n]=diff(ww[0][n],ww[1][n],ww[2][n]);
		for(int n=0;n<=N;n++)
			ww[0][n]=w[0][n]+(x1[n]+2*x2[n]+2*x3[n]+x4[n])/6*dt;
		return pDiff(ww[0],N,dx);
	}

	private void draw(double[]w,int n)
	{	int sx_=0,sy_=0;
		for(int nx=0;nx<=N;nx++)
		{	int sx=getSx(getX(nx));
			int sy=getSy(w[nx]);
			if(nx!=0&&Math.abs(sy)<=FR2&&Math.abs(sy_)<=FR2)
				XG.line(sx_,sy_,sx,sy,XColor.getColor((n*160)/NL),2);
			sx_=sx;sy_=sy;
		}
	}

	public double[][]pDiff(double[]u,int N,double dx)
	{	double[][]w=new double[3][N+1];
		for(int n=0;n<=N;n++)
			w[0][n]=u[n];
		for(int j=0;j<2;j++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0)
					w[j+1][n]=(w[j][n+1]-w[j][n])/dx;
				else if(n==N)
					w[j+1][n]=(w[j][n]-w[j][n-1])/dx;
				else
					w[j+1][n]=(w[j][n+1]-w[j][n-1])/(2*dx);
			}
		}
		return w;
	}

	public F0401b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"KEXz֐̊gU");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0401b app=new F0401b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double getX(int nx){return x_min+dx*nx;}
	private int getNx(double x){return XMath.fint((x-x_min)/dx);}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}