// gUɂ鎞ԃJIX

package f04;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0402a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	double Div=1.0E4;
	int FR=100;
	int N=2*FR;
	int NL=0;
	double h=0.1,r=3.6,m=3.24;
	double[]FP=new double[2];
	double x_min=0.0,x_max=(double)N;
	double y_min=0.0,y_max=(double)N;
	double dx=(x_max-x_min)/N;
	double dy=(y_max-y_min)/N;
	double mx=(x_max+x_min)/2;
	double my=(y_max+y_min)/2;
	double u_min=0.0,u_max=0.9;
	double u_min_=10000.0,u_max_=-10000.0;

	private double initU0(double x,double y)
	{	return FP[0]*(1+0.5*Math.sin(Math.PI*(x-mx)/x_max));
	}

	private double initU1(double x,double y)
	{	return FP[1]*(1+0.5*Math.sin(Math.PI*(y-my)/y_max));
	}

	private double[]getFP()
	{	double[]fp=new double[2];
		fp[0]=Math.sqrt(m/(r-m))*h;
		double f=fp[0]*fp[0]/(h*h+fp[0]*fp[0]);
		fp[1]=fp[0]*(1-fp[0])/f;
		return fp;
	}

	private void myPaint()
	{	XColor.setAokoSpectra3();
		XG.set0(FC,1);
		XG.rectangle(-FR-36-1,FR+14+1,FR+14+1,-FR-36-1,XColor.Color16[0]);

		FP=getFP();

		double[][][][]w=new double[2][5][N+1][N+1];
		double[][][][]ww=new double[2][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	ww[0][0][nx][ny]=initU0(getX(nx),getY(ny));
				ww[1][0][nx][ny]=initU1(getX(nx),getY(ny));
			}
		}
		w=XAnalysis.pDiffS(ww[0][0],ww[1][0],N,dx,dy);

		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	int sx=getSx(getX(nx));
				int sy=getSy(getY(ny));
				int col=(int)(256*(w[0][0][nx][ny]-u_min)/(u_max-u_min));
				if(w[0][0][nx][ny]>u_max_)
					u_max_=w[0][0][nx][ny];
				if(w[0][0][nx][ny]<u_min_)
					u_min_=w[0][0][nx][ny];
				XG.pixel(sx,sy,XColor.getAokoColor(col));
			}
		}
		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);

		XG.string2(-FR-32,-FR-28,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,20);

		XG.string2(FR/2-5,-FR-28,"x",XColor.Color16[0],
			"Arial",Font.ITALIC,18);
		XG.string2(-FR-5,-FR-18,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-15,-FR-18,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(FR-17,-FR-18,"200",XColor.Color16[0],
			"Arial",Font.PLAIN,18);

		XG.stringR(FC.x-FR-18,FC.y-FR/2+5,"y",XColor.Color16[0],
			"Arial",Font.ITALIC,18,90.0);
		XG.string2(-FR-13,-FR-7,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-FR-33,-7,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-FR-33,FR-7,"200",XColor.Color16[0],
			"Arial",Font.PLAIN,18);

		XG.string(10,140,"r="+r,XColor.Color16[0],16);
		XG.string(10,160,"m="+m,XColor.Color16[0],16);
		XG.string(10,180,"h="+h,XColor.Color16[0],16);
		XG.string(10,300,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,460,"N="+N,XColor.Color16[0],16);
		XG.string(10,500,"x="+x_min+"<<"+x_max,XColor.Color16[0],16);
		XG.string(10,520,"y="+y_min+"<<"+y_max,XColor.Color16[0],16);
		XG.string(10,540,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,560,"u_="+XMath.fdouble(u_min_,3)+"<<"
			+XMath.fdouble(u_max_,3),XColor.Color16[0],16);
	}

	public F0402a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"gUɂ鎞ԃJIX");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0402a app=new F0402a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double getX(int nx){return x_min+dx*nx;}
	private double getY(int ny){return y_min+dy*ny;}
	private int getNx(double x){return XMath.fint((x-x_min)/dx);}
	private int getNy(double y){return XMath.fint((y-y_min)/dy);}

	private double setSx(int sx){return dx*sx+mx;}
	private double setSy(int sy){return dy*sy+my;}
	private int getSx(double x){return XMath.fint((x-mx)/dx);}
	private int getSy(double y){return XMath.fint((y-my)/dy);}
}