// gUɂ`[Op^[

package f04;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import xxx.*;

public class F0405a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=100;
	int N=2*FR,NP=100;
	int NL=0;
	double a=0.8,r=1.0,m=0.96,h0=1.0,h1=0.6;
	double f0=0.25,s=10.0;
	double[]FP=new double[2];
	double x_min=0.0,x_max=(double)N;
	double y_min=0.0,y_max=(double)N;
	double dx=(x_max-x_min)/N;
	double dy=(y_max-y_min)/N;
	double mx=(x_max+x_min)/2;
	double my=(y_max+y_min)/2;
	double v_min=0.0,v_max=6.0;
	double v_min_=10000.0,v_max_=-10000.0;

	private double[][]initU()
	{	double[][]u=new double[N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				u[nx][ny]=FP[0];
		}
		return u;
	}

	private double[][]initV()
	{	double[][]u=new double[N+1][N+1];
		double[][]uu=new double[N+1][N+1];
		double[][]peak=new double[2][NP];
		Random rd=new Random(0);
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
				u[nx][ny]=0.0;
		for(int n=0;n<NP;n++)
		{	peak[0][n]=0.1*mx+0.9*(x_max-x_min)*rd.nextDouble();
			peak[1][n]=0.1*my+0.9*(y_max-y_min)*rd.nextDouble();
		}
		for(int n=0;n<NP;n++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	double x=(getX(nx)-peak[0][n])/s;
					double y=(getY(ny)-peak[1][n])/s;
					double f=f0*Math.exp(-(x*x+y*y));
					uu[nx][ny]=uu[nx][ny]+Math.pow(-1.0,n)*f;
				}
			}
		}
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
				u[nx][ny]=FP[1]*(1+uu[nx][ny]);
		return u;
	}

	private double[]getFP()
	{	double[]f=new double[2];
		double A=a*r/m;
		f[1]=Math.sqrt(A/(1-A))*h1;
		f[0]=a*h0/(f[1]-a);
		return f;
	}

	private void myPaint()
	{	XColor.setAokoSpectra3();
		XG.set0(FC,1);
		XG.rectangle(-FR-36-1,FR+14+1,FR+14+1,-FR-36-1,XColor.Color16[0]);

		FP=getFP();

		double[][][][]w=new double[2][5][N+1][N+1];
		double[][][][]ww=new double[2][5][N+1][N+1];
		double[][]u_ini=new double[N+1][N+1];
		double[][]v_ini=new double[N+1][N+1];
		u_ini=initU();
		v_ini=initV();
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	ww[0][0][nx][ny]=u_ini[nx][ny];
				ww[1][0][nx][ny]=v_ini[nx][ny];
			}
		}
		w=XAnalysis.pDiffS(ww[0][0],ww[1][0],N,dx,dy);

		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	int sx=getSx(getX(nx));
				int sy=getSy(getY(ny));
				int col=(int)(256*(w[1][0][nx][ny]-v_min)/(v_max-v_min));
				if(w[1][0][nx][ny]>v_max_)
					v_max_=w[1][0][nx][ny];
				if(w[1][0][nx][ny]<v_min_)
					v_min_=w[1][0][nx][ny];
				XG.pixel(sx,sy,XColor.getAokoColor(col));
			}
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);

		XG.string2(-FR-32,-FR-28,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,20);

		XG.string2(FR/2-5,-FR-28,"x",XColor.Color16[0],
			"Arial",Font.ITALIC,18);
		XG.string2(-FR-5,-FR-18,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-15,-FR-18,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(FR-17,-FR-18,"200",XColor.Color16[0],
			"Arial",Font.PLAIN,18);

		XG.stringR(FC.x-FR-18,FC.y-FR/2+5,"y",XColor.Color16[0],
			"Arial",Font.ITALIC,18,90.0);
		XG.string2(-FR-13,-FR-7,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-FR-33,-7,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-FR-33,FR-7,"200",XColor.Color16[0],
			"Arial",Font.PLAIN,18);

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,160,"r="+r,XColor.Color16[0],16);
		XG.string(10,180,"m="+m,XColor.Color16[0],16);
		XG.string(10,200,"h0="+h0,XColor.Color16[0],16);
		XG.string(10,220,"h1="+h1,XColor.Color16[0],16);
		XG.string(10,300,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,460,"N="+N,XColor.Color16[0],16);
		XG.string(10,500,"x="+x_min+"<<"+x_max,XColor.Color16[0],16);
		XG.string(10,520,"y="+y_min+"<<"+y_max,XColor.Color16[0],16);
		XG.string(10,540,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		XG.string(10,560,"v_="+XMath.fdouble(v_min_,3)+"<<"
			+XMath.fdouble(v_max_,3),XColor.Color16[0],16);
	}

	public F0405a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"gUɂ`[Op^[");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0405a app=new F0405a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double getX(int nx){return x_min+dx*nx;}
	private double getY(int ny){return y_min+dy*ny;}
	private int getNx(double x){return XMath.fint((x-x_min)/dx);}
	private int getNy(double y){return XMath.fint((y-y_min)/dy);}

	private double setSx(int sx){return dx*sx+mx;}
	private double setSy(int sy){return dy*sy+my;}
	private int getSx(double x){return XMath.fint((x-mx)/dx);}
	private int getSy(double y){return XMath.fint((y-my)/dy);}
}