// X[AgN^

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0501b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics3D XG;
	int NL=200000,FR=240,k=22,x0=8,y0=154;
	double a=0.2,b=5.0,dt=0.01;
	double rtx=18.0,rty=45.0;
	XPointD3 p0=new XPointD3(5.0,0.0,0.0);
	XPointD3[]axis={new XPointD3(1.1*FR,0,0),
		new XPointD3(0,1.6*FR,0),new XPointD3(0,0,1.1*FR)};

	XPointD3 diff(XPointD3 p)
	{	double u=-p.y-p.z;
		double v=p.x+a*p.y;
		double w=a-b*p.z+p.x*p.z;
		return new XPointD3(u,v,w);
	}

	private void myPaint()
	{	XTimer t=new XTimer();
		t.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-1,-FR-1,FR+1,FR+1,XColor.Color16[0]);

		XG.string2(-FR+8,FR-40,"(b)",XColor.Color16[0],"Arial",Font.PLAIN,40);

		XPointD3 p,pp,p_,pp_;
		XG.set0(FC.x+x0,FC.y+y0,1);
		XG.setProj(rtx,rty);

		int[]ax=new int[3];
		int[]ay=new int[3];
		for(int i=0;i<3;i++)
		{	p=XG.getProj(axis[i]);
			ax[i]=XMath.fint(p.x);
			ay[i]=XMath.fint(p.y);
			if(i==1)
				XG.arrow(0,0,ax[i],ay[i],XColor.Color16[0],3,20);
			else
				XG.arrow(-ax[i],-ay[i],ax[i],ay[i],XColor.Color16[0],3,20);
		}

		XG.string2(-8,-26,"0",XColor.Color16[0],"Arial",Font.PLAIN,31);
		XG.string2(ax[0]+2,ay[0]-6,"y",XColor.Color16[0],"Arial",Font.ITALIC,32);
		XG.string2(ax[1]-22,ay[1]-8,"z",XColor.Color16[0],"Arial",Font.ITALIC,32);
		XG.string2(ax[2]+2,ay[2]-12,"x",XColor.Color16[0],"Arial",Font.ITALIC,32);

		p=p0;
		p_=XG.getProj(new XPointD3(k*p.y,k*p.z,k*p.x));
		for(int n=0;n<NL;n++)
		{	pp=runge_kutta(p);
			pp_=XG.getProj(new XPointD3(k*pp.y,k*pp.z,k*pp.x));
			XG.line(XMath.fint(p_.x),XMath.fint(p_.y),
				XMath.fint(pp_.x),XMath.fint(pp_.y),XColor.Color16[0]);
			p=pp;
			p_=pp_;
		}

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,160,"b="+b,XColor.Color16[0],16);
		XG.string(10,200,"p0=("+p0.x+","+p0.y+","+p0.z+")",XColor.Color16[0],16);
		XG.string(10,300,"rtx="+rtx,XColor.Color16[0],16);
		XG.string(10,320,"rty="+rty,XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		t.getTimer();
		XG.string(10,720,"Time="+t.Time,XColor.Color16[0],16);
	}

	XPointD3 runge_kutta(XPointD3 p)
	{	XPointD3 pp0=diff(p);
		XPointD3 pp1=diff(XMath.plus(p,XMath.mlt(pp0,dt/2)));
		XPointD3 pp2=diff(XMath.plus(p,XMath.mlt(pp1,dt/2)));
		XPointD3 pp3=diff(XMath.plus(p,XMath.mlt(pp2,dt)));
		return XMath.plus(p,XMath.mlt(XMath.plus(XMath.plus(pp0,XMath.mlt(2,pp1)),
			XMath.plus(XMath.mlt(2,pp2),pp3)),dt/6));
	}

	public F0501b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"X[AgN^");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics3D(getGraphics());
	}

	public static void main(String[]argv)
	{	F0501b app=new F0501b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}
}