// łPȕۑnɂJIX

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0503a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=200000,FR=200,n=5;
	double Div=1.0E4,dt=0.01;
	double a=0.01;
	double[]p0={0.02,0.0,0.0};
	double[]FP={Math.sqrt(a),0.0,0.0};
	double[][]LM=new double[3][2];
	double u_min=-0.25,u_max=0.25;
	double v_min=-0.25,v_max=0.25;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[1];
		xx[1]=x[2];
		xx[2]=-a-x[1]+x[0]*x[0];
		return xx;
	}

	private double[][]getLM()
	{	double[][]A=new double[3][3];
		A[0][0]=0;A[0][1]=1;A[0][2]=0;
		A[1][0]=0;A[1][1]=0;A[1][2]=1;
		A[2][0]=2*FP[0];A[2][1]=-1;A[2][2]=0;
		return XAlgebra.eigenValues33Mr(A);
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		LM=getLM();

		double D=2*(double)FR/n;
		for(int i=0;i<n;i++)
			XG.line(-FR+XMath.fint((i+0.5)*D),-FR,-FR+XMath.fint((i+0.5)*D),FR,XColor.Color16[8]);
		for(int i=0;i<n;i++)
			XG.line(-FR,-FR+XMath.fint((i+0.5)*D),FR,-FR+XMath.fint((i+0.5)*D),XColor.Color16[8]);

		double[]p=p0;
		Point sp_=new Point(getSx(p[0]),getSy(p[1]));
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,3);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
			if(p2>=Div)
				break;
			Point sp=new Point(getSx(p[0]),getSy(p[1]));
			if(n>NL/100)
				XG.line(sp_,sp,XColor.Color16[0]);
			sp_=sp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(-FR+6,FR-38,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.cross(getSx(FP[0]),getSy(FP[1]),3,XColor.Color16[7],3);
		XG.string2(getSx(FP[0])+6,getSy(FP[1])-12,"F",XColor.Color16[7],
			"Arial",Font.PLAIN,32);

		XG.string2(2*FR/5-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-4*FR/5-34,-FR-32,""+XMath.fdouble((9*u_min+u_max)/10,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-9,-FR-32,""+XMath.fint((u_min+u_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(4*FR/5-23,-FR-32,""+XMath.fdouble((u_min+9*u_max)/10,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-2*FR/5+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-61,-4*FR/5-12,""+XMath.fdouble((9*v_min+v_max)/10,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-12,""+XMath.fint((v_min+v_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,4*FR/5-12,""+XMath.fdouble((v_min+9*v_max)/10,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,200,"p0=("+p0[0]+","+p0[1]+","+p0[2]+")",XColor.Color16[0],16);
		XG.string(10,300,"FP0=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+","+XMath.fdouble(FP[2],3)+")",
			XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		XG.string(10,500,"LM0="+XMath.fdouble(LM[0][0],3)+"+"+XMath.fdouble(LM[0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,520,"LM1="+XMath.fdouble(LM[1][0],3)+"+"+XMath.fdouble(LM[1][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,540,"LM2="+XMath.fdouble(LM[2][0],3)+"+"+XMath.fdouble(LM[2][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,560,"S="+XMath.fdouble(LM[0][0]+LM[1][0]+LM[2][0],3)+
			"+"+XMath.fdouble(LM[0][1]+LM[1][1]+LM[2][1],3)+"i",XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0503a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"łPȕۑnɂJIX");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0503a app=new F0503a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}