// Wpj[YAgN^

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0505a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=100000000,FR=200,nx=6,ny=9;
	double Conv=1.0E-10,dt=Math.PI/360;
	double k=0.05,B=7.0;
	XPointD p0=new XPointD(2.1,0.0);
	double u_min=1.2,u_max=3.6;
	double v_min=-4.8,v_max=6.0;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	XPointD diff(XPointD p,double t)
	{	double z=Math.cos(t);
		double u=p.y;
		double v=-k*p.y-p.x*p.x*p.x+B*z;
		return new XPointD(u,v);
	}

	private void myPaint()
	{	XTimer tm=new XTimer();
		tm.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double Dx=2*(double)FR/nx,Dy=2*(double)FR/ny;
		for(int i=1;i<nx;i++)
			XG.line(-FR+XMath.fint(i*Dx),-FR,-FR+XMath.fint(i*Dx),FR,XColor.Color16[8]);
		for(int i=1;i<ny;i++)
			XG.line(-FR,-FR+XMath.fint(i*Dy),FR,-FR+XMath.fint(i*Dy),XColor.Color16[8]);

		double t;
		Point ps=new Point();
		XPointD p,pp;
		p=p0;
		for(int n=0;n<NL;n++)
		{	t=n*dt;
			pp=runge_kutta(p,t);
			ps.x=XMath.fint(getSx(pp.x));
			ps.y=XMath.fint(getSy(pp.y));
			int N=XMath.fint(t/(2*Math.PI));
			if(Math.abs(t-N*2*Math.PI)<Conv)
				XG.pixel(ps.x,ps.y,XColor.Color16[0]);
			p=pp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(-FR+8,FR-40,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-23,-FR-32,""+u_min,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-23,-FR-32,""+XMath.fdouble((u_min+u_max)/2,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-26,-FR-32,""+u_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-XMath.fint((double)FR/9)+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-61,-FR-6,""+v_min,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-61,-XMath.fint(5*(double)FR/9)-12,""+XMath.fdouble((7*v_min+2*v_max)/9,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-XMath.fint((double)FR/9)-12,""+XMath.fint((5*v_min+4*v_max)/9),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,XMath.fint((double)FR/3)-12,""+XMath.fdouble((v_min+2*v_max)/3,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,XMath.fint(7*(double)FR/9)-12,""+XMath.fdouble((v_min+8*v_max)/9,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"k="+k,XColor.Color16[0],16);
		XG.string(10,160,"B="+B,XColor.Color16[0],16);
		XG.string(10,200,"p0=("+p0.x+","+p0.y+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt=PI/"+XMath.fint(Math.PI/dt),XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		tm.getTimer();
		XG.string(10,720,"Time="+tm.Time,XColor.Color16[0],16);
	}

	XPointD runge_kutta(XPointD p,double t)
	{	XPointD pp0=diff(p,t);
		XPointD pp1=diff(XMath.plus(p,XMath.mlt(pp0,dt/2)),t+dt/2);
		XPointD pp2=diff(XMath.plus(p,XMath.mlt(pp1,dt/2)),t+dt/2);
		XPointD pp3=diff(XMath.plus(p,XMath.mlt(pp2,dt)),t+dt);
		return XMath.plus(p,XMath.mlt(XMath.plus(XMath.plus(pp0,XMath.mlt(2,pp1)),
			XMath.plus(XMath.mlt(2,pp2),pp3)),dt/6));
	}

	public F0505a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"Wpj[YAgN^");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0505a app=new F0505a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}