// łPȋUnɂ|AJʑ

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0506b extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=100000000,FR=200,nx=6,ny=7;
	double Div=1.0E4,dt=0.001,PI=Math.PI,PS=Math.cos(PI/2);
	double a=0.1,b=0.53;
	double A=0.156,w=0.6;
	double[]p0={-0.25,0.0,0.0};
	double u_min=-0.5,u_max=0.7;
	double v_min=-0.3,v_max=0.4;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[1];
		xx[1]=a-b*x[1]-x[0]*x[0]+A*Math.cos(x[2]);
		xx[2]=w;
		return xx;
	}

	private void myPaint()
	{	XTimer t=new XTimer();
		t.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double Dx=2*(double)FR/nx,Dy=2*(double)FR/ny;
		for(int i=0;i<nx;i++)
			XG.line(-FR+XMath.fint((2*i+1)*Dx/2),-FR,-FR+XMath.fint((2*i+1)*Dx/2),FR,XColor.Color16[8]);
		for(int i=1;i<ny;i++)
			XG.line(-FR,-FR+XMath.fint(i*Dy),FR,-FR+XMath.fint(i*Dy),XColor.Color16[8]);

		double[]p=p0;
		double[]p_=p0;
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,3);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
			if(p2>Div)
				break;
			if(n>NL/100)
			{	if(Math.cos(p_[2])-PS>0&&Math.cos(p[2])-PS<0)
				{	int sx=getSx(p[0]);
					int sy=getSy(p[1]);
					if(Math.abs(sx)<=FR&&Math.abs(sy)<=FR)
						XG.pixel(sx,sy,XColor.Color16[0]);
				}
				if(Math.cos(p_[2])-PS<0&&Math.cos(p[2])-PS>0)
				{	int sx=getSx(p[0]);
					int sy=getSy(p[1]);
					if(Math.abs(sx)<=FR&&Math.abs(sy)<=FR)
						XG.pixel(sx,sy,XColor.Color16[15]);
				}
			}
			p[2]=p[2]-(2*PI)*Math.floor(p[2]/(2*PI));
			p_=p;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(-FR+8,FR-40,"(b)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(FR/6-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-XMath.fint(5*(double)FR/6)-34,-FR-32,""+XMath.fdouble((11*u_min+u_max)/12,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-XMath.fint((double)FR/6)-9,-FR-32,""+XMath.fint((7*u_min+5*u_max)/12),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(XMath.fint((double)FR/2)-23,-FR-32,""+XMath.fdouble((u_min+3*u_max)/4,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(XMath.fint(5*(double)FR/6)-23,-FR-32,""+XMath.fdouble((u_min+11*u_max)/12,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-XMath.fint((double)FR/7)+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-61,-XMath.fint(5*(double)FR/7)-12,""+XMath.fdouble((6*v_min+v_max)/7,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-XMath.fint((double)FR/7)-12,""+XMath.fint((4*v_min+3*v_max)/7),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,XMath.fint(3*(double)FR/7)-12,""+XMath.fdouble((2*v_min+5*v_max)/7,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,160,"b="+b,XColor.Color16[0],16);
		XG.string(10,180,"A="+XMath.fdouble(A,4),XColor.Color16[0],16);
		XG.string(10,200,"w="+XMath.fdouble(w,4),XColor.Color16[0],16);
		XG.string(10,300,"p0=("+p0[0]+","+p0[1]+","+p0[2]+")",XColor.Color16[0],16);
		XG.string(10,320,"PS="+XMath.fdouble(PS,3),XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		t.getTimer();
		XG.string(10,720,"Time="+t.Time,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0506b()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"łPȋUnɂ|AJʑ");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0506b app=new F0506b();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}