// łPȋUnɂXgWAgN^

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0507a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=500000,FR=200,n=5;
	double Div=1.0E4,PI=Math.PI,dt=0.01;
	double a=0.1,b=0.53;
	double A=0.1475,w=0.6;
	double[]p0={1.0,0.0,0.0};
	double[]FP=new double[3];
	double u_min=-2.5,u_max=2.5;
	double v_min=-1.0,v_max=4.0;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[1];
		xx[1]=a-b*x[0]-x[0]*x[1]+A*Math.cos(x[2]);
		xx[2]=w;
		return xx;
	}

	private double[]getFP()
	{	double[]fp=new double[3];
		fp[0]=a/b;
		fp[1]=0.0;
		fp[2]=0.0;
		return fp;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double D=2*(double)FR/n;
		for(int i=0;i<n;i++)
			XG.line(-FR+XMath.fint((2*i+1)*D/2),-FR,-FR+XMath.fint((2*i+1)*D/2),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(i*D),FR,-FR+XMath.fint(i*D),XColor.Color16[8]);

		FP=getFP();

		double[]p=p0;
		Point sp_=new Point(getSx(p[0]),getSy(p[1]));
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,3);
			p=pp;
			p[2]=p[2]-(2*PI)*Math.floor(p[2]/(2*PI));
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
			if(p2>=Div)
				break;
			Point sp=new Point(getSx(p[0]),getSy(p[1]));
			if(n>NL/100&&Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR)
				XG.line(sp_,sp,XColor.Color16[0]);
			sp_=sp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(-FR+8,FR-40,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(2*FR/5-11,-FR-50,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-4*FR/5-33,-FR-32,"-2.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-9,-FR-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(4*FR/5-22,-FR-32,"2.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-28,FC.y-3*FR/5+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-3*FR/5-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR/5-12,"2.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,"4.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,160,"b="+b,XColor.Color16[0],16);
		XG.string(10,180,"A="+XMath.fdouble(A,4),XColor.Color16[0],16);
		XG.string(10,200,"w="+XMath.fdouble(w,4),XColor.Color16[0],16);
		XG.string(10,300,"p0=("+p0[0]+","+p0[1]+","+p0[2]+")",XColor.Color16[0],16);
		XG.string(10,320,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+","+XMath.fdouble(FP[2],3)+")",
			XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0507a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"łPȋUnɂXgWAgN^");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0507a app=new F0507a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}