// oȎnɂ郊~bgTCN

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0508a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=300000,FR=200,n=6;
	double Div=1.0E4,dt=0.005;
	double a=0.08,b=0.2;
	double[]p0={1.0,0.0,0.0};
	double[]FP=new double[3];
	double[][]LM=new double[3][2];
	double u_min=-1.0,u_max=5.0;
	double v_min=-1.0,v_max=2.0;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[1];
		xx[1]=x[2];
		xx[2]=a-b*x[0]-x[1]+x[2]-x[0]*x[2];
		return xx;
	}

	private double[]getFP()
	{	double[]fp=new double[3];
		fp[0]=a/b;
		fp[1]=0.0;
		fp[2]=0.0;
		return fp;
	}

	private double[][]getLM()
	{	double[][]A=new double[3][3];
		A[0][0]=0;
		A[0][1]=1;
		A[0][2]=0;
		A[1][0]=0;
		A[1][1]=0;
		A[1][2]=1;
		A[2][0]=-b-FP[2];
		A[2][1]=-1;
		A[2][2]=1-FP[0];
		return XAlgebra.eigenValues33Mr(A);
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double D=2.0*FR/n;
		for(int i=1;i<n;i++)
			XG.line(-FR+XMath.fint(D*i),-FR,-FR+XMath.fint(D*i),FR,XColor.Color16[8]);
		for(int i=1;i<n;i++)
			XG.line(-FR,-FR+XMath.fint(D*i),FR,-FR+XMath.fint(D*i),XColor.Color16[8]);

		FP=getFP();
		LM=getLM();

		double[]p=p0;
		Point sp_=new Point(getSx(p[0]),getSy(p[1]));
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,3);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
			if(p2>=Div)
				break;
			Point sp=new Point(getSx(p[0]),getSy(p[1]));
			if(Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR&&n>NL/3)
				XG.line(sp_,sp,XColor.Color16[0]);
			sp_=sp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(-FR+8,FR-40,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.cross(getSx(FP[0]),getSy(FP[1]),3,XColor.Color16[0],3);
		XG.string2(getSx(FP[0])-12,getSy(FP[1])+6,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string2(XMath.fint((double)FR/3)-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-XMath.fint(2*(double)FR/3)-9,-FR-32,""+XMath.fint((5*u_min+u_max)/6),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-23,-FR-32,""+XMath.fdouble((u_min+u_max)/2,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(XMath.fint(2*(double)FR/3)-23,-FR-32,""+XMath.fdouble((u_min+5*u_max)/6,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-61,-FR-12,""+v_min,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-FR/3-12,"0",XColor.Color16[0],
				"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR/3-12,""+XMath.fdouble((v_min+2*v_max)/3,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,160,"b="+b,XColor.Color16[0],16);
		XG.string(10,200,"p0=("+p0[0]+","+p0[1]+","+p0[2]+")",XColor.Color16[0],16);
		XG.string(10,300,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+","+XMath.fdouble(FP[2],3)+")",
			XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
		XG.string(10,500,"LM0="+XMath.fdouble(LM[0][0],3)+"+"+XMath.fdouble(LM[0][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,520,"LM1="+XMath.fdouble(LM[1][0],3)+"+"+XMath.fdouble(LM[1][1],3)+"i",XColor.Color16[0],16);
		XG.string(10,540,"LM2="+XMath.fdouble(LM[2][0],3)+"+"+XMath.fdouble(LM[2][1],3)+"i",XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0508a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"oȎnɂ郊~bgTCN");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0508a app=new F0508a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}