// oȎnɂtN^ȗ敪z

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0509a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=10000,FR=200,step=1;
	double Div=1.0E10,dt=0.01,xc=3.0;
	double a=0.08,b=0.2,d=1.0;
	double[]p0=new double[3];
	double[]FP=new double[3];
	double u_min=a/b-d,u_max=a/b+d;
	double v_min=-d,v_max=d;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[1];
		xx[1]=x[2];
		xx[2]=a-b*x[0]-x[1]+x[2]-x[0]*x[2];
		return xx;
	}

	private double[]getFP()
	{	double[]fp=new double[3];
		fp[0]=a/b;
		fp[1]=0.0;
		fp[2]=0.0;
		return fp;
	}

	private int basin(double[]p0)
	{	double[]p=p0;
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,3);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1]+p[2]*p[2];
			if(p2>Div)
				return 15;
			if(n>(int)(0.9*NL)&&p[0]>xc)
				return -1;
		}
		return 0;
	}

	private void myPaint()
	{	XTimer t=new XTimer();
		t.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		XG.line(-FR,0,FR,0,XColor.Color16[8]);
		XG.line(0,-FR,0,FR,XColor.Color16[8]);

		FP=getFP();

		p0[0]=FP[0];
		p0[1]=FP[1];
		p0[2]=FP[2];
		for(int sx=-FR;sx<=FR;sx=sx+step)
		{	p0[0]=setSx(sx);
			for(int sy=-FR;sy<=FR;sy=sy+step)
			{	p0[1]=setSy(sy);
				int n=basin(p0);
				if(n>=0)
					XG.pixel(sx,sy,XColor.Color16[n]);
			}
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.string2(FR-56,FR-40,"(a)",XColor.Color16[7],
			"Arial",Font.PLAIN,40);

		XG.string2(-FR/2-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(FR/2-44,-FR-52,"(}"+d+")",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-34,-FR-32,""+XMath.fdouble(u_min,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-22,-FR-32,""+XMath.fdouble((u_min+u_max)/2,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-27,-FR-32,""+XMath.fdouble(u_max,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y+FR/2+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.stringR(FC.x-FR-32,FC.y-FR/2+44,"(}"+d+")",XColor.Color16[0],
			"Arial",Font.PLAIN,32,90.0);
		XG.string2(-FR-61,-FR-6,""+v_min,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR-12,""+v_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,160,"b="+b,XColor.Color16[0],16);
		XG.string(10,300,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+","+XMath.fdouble(FP[2],3)+")",
			XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+XMath.fdouble(u_min,8)+"<<"
			+XMath.fdouble(u_max,8),XColor.Color16[0],16);
		XG.string(10,460,"v="+XMath.fdouble(v_min,8)+"<<"
			+XMath.fdouble(v_max,8),XColor.Color16[0],16);
		XG.string(10,480,"d="+d,XColor.Color16[0],16);
		t.getTimer();
		XG.string(10,720,"Time="+t.Time,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0509a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"oȎnɂtN^ȗ敪z");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0509a app=new F0509a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}