// łPȔgUɂ鎞ԃJIX

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0512a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=100;
	int N=2*FR;
	int NL=2000;
	double dt=0.32;
	double a=0.1;
	double[][]FP=new double[2][2];
	double x_min=0.0,x_max=(double)N;
	double y_min=0.0,y_max=(double)N;
	double dx=(x_max-x_min)/N;
	double dy=(y_max-y_min)/N;
	double mx=(x_max+x_min)/2;
	double my=(y_max+y_min)/2;
	double u_min=-0.7,u_max=0.6;
	double u_min_=10000.0,u_max_=-10000.0;

	private double initU0(double x,double y)
	{	return FP[0][0]*(1+0.5*Math.sin(Math.PI*(x-mx)/x_max));
	}

	private double initU1(double x,double y)
	{	return FP[0][1]+0.5*Math.sin(Math.PI*(y-my)/y_max);
	}

	private double[]diff(double u00,double u01,double u02,double u03,double u04,
						 double u10,double u11,double u12,double u13,double u14)
	{	double[]x=new double[2];
		x[0]=u02+u04+u10;
		x[1]=u12+u14+a-u00+u00*u10-u00*u00;
		return x;
	}

	private double[][]getFP()
	{	double[][]fp=new double[2][2];
		double[][]x=new double[2][2];
		x=XAlgebra.roots2dEq(1.0,-a);
		fp[0][0]=x[0][0];
		fp[0][1]=0.0;
		fp[1][0]=x[1][0];
		fp[1][1]=0.0;
		return fp;
	}

	private void myPaint()
	{	XTimer tm=new XTimer();
		tm.setTimer();

		XColor.setCycSpectra(1);
		XG.set0(FC,1);
		XG.rectangle(-FR-36-1,FR+14+1,FR+14+1,-FR-36-1,XColor.Color16[0]);

		FP=getFP();

		double[][][][]w=new double[2][5][N+1][N+1];
		double[][][][]ww=new double[2][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	ww[0][0][nx][ny]=initU0(getX(nx),getY(ny));
				ww[1][0][nx][ny]=initU1(getX(nx),getY(ny));
			}
		}
		w=XAnalysis.pDiffS(ww[0][0],ww[1][0],N,dx,dy);

		for(int n=0;n<NL;n++)
		{	ww=rungeKutta(w);
			w=ww;
		}

		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	int sx=getSx(getX(nx));
				int sy=getSy(getY(ny));
				int col=(int)(256*(w[0][0][nx][ny]-u_min)/(u_max-u_min));
				if(w[0][0][nx][ny]>u_max_)
					u_max_=w[0][0][nx][ny];
				if(w[0][0][nx][ny]<u_min_)
					u_min_=w[0][0][nx][ny];
				XG.pixel(sx,sy,XColor.getColor(col));
			}
		}
		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);

		XG.string2(-FR-32,-FR-28,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,20);

		XG.string2(FR/2-5,-FR-28,"x",XColor.Color16[0],
			"Arial",Font.ITALIC,18);
		XG.string2(-FR-5,-FR-18,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-15,-FR-18,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(FR-17,-FR-18,"200",XColor.Color16[0],
			"Arial",Font.PLAIN,18);

		XG.stringR(FC.x-FR-18,FC.y-FR/2+5,"y",XColor.Color16[0],
			"Arial",Font.ITALIC,18,90.0);
		XG.string2(-FR-13,-FR-7,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-FR-33,-7,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,18);
		XG.string2(-FR-33,FR-7,"200",XColor.Color16[0],
			"Arial",Font.PLAIN,18);

		XG.string(10,140,"a="+a,XColor.Color16[0],16);
		XG.string(10,300,"FP0=("+XMath.fdouble(FP[0][0],3)+","
			+XMath.fdouble(FP[0][1],3)+")",XColor.Color16[0],16);
		XG.string(10,320,"FP1=("+XMath.fdouble(FP[1][0],3)+","
			+XMath.fdouble(FP[1][1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"TL="+NL*dt,XColor.Color16[0],16);
		XG.string(10,460,"N="+N,XColor.Color16[0],16);
		XG.string(10,500,"x="+x_min+"<<"+x_max,XColor.Color16[0],16);
		XG.string(10,520,"y="+y_min+"<<"+y_max,XColor.Color16[0],16);
		XG.string(10,540,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,560,"u_="+XMath.fdouble(u_min_,3)+"<<"
			+XMath.fdouble(u_max_,3),XColor.Color16[0],16);
		tm.getTimer();
		XG.string(10,720,"Time="+tm.Time,XColor.Color16[0],16);
	}

	private double[][][][]rungeKutta(double[][][][]w)
	{	double[][][][]ww=new double[2][5][N+1][N+1];
		double[][][][]w_=new double[2][5][N+1][N+1];
		double[][][]x1=new double[N+1][N+1][2];
		double[][][]x2=new double[N+1][N+1][2];
		double[][][]x3=new double[N+1][N+1][2];
		double[][][]x4=new double[N+1][N+1][2];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	x1[nx][ny]=diff(w[0][0][nx][ny],w[0][1][nx][ny],w[0][2][nx][ny],
								w[0][3][nx][ny],w[0][4][nx][ny],
								w[1][0][nx][ny],w[1][1][nx][ny],w[1][2][nx][ny],
								w[1][3][nx][ny],w[1][4][nx][ny]);
				w_[0][0][nx][ny]=w[0][0][nx][ny]+x1[nx][ny][0]/2*dt;
				w_[1][0][nx][ny]=w[1][0][nx][ny]+x1[nx][ny][1]/2*dt;
			}
		}
		ww=XAnalysis.pDiffS(w_[0][0],w_[1][0],N,dx,dy);
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	x2[nx][ny]=diff(ww[0][0][nx][ny],ww[0][1][nx][ny],ww[0][2][nx][ny],
								ww[0][3][nx][ny],ww[0][4][nx][ny],
								ww[1][0][nx][ny],ww[1][1][nx][ny],ww[1][2][nx][ny],
								ww[1][3][nx][ny],ww[1][4][nx][ny]);
				w_[0][0][nx][ny]=w[0][0][nx][ny]+x2[nx][ny][0]/2*dt;
				w_[1][0][nx][ny]=w[1][0][nx][ny]+x2[nx][ny][1]/2*dt;
			}
		}
		ww=XAnalysis.pDiffS(w_[0][0],w_[1][0],N,dx,dy);
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	x3[nx][ny]=diff(ww[0][0][nx][ny],ww[0][1][nx][ny],ww[0][2][nx][ny],
								ww[0][3][nx][ny],ww[0][4][nx][ny],
								ww[1][0][nx][ny],ww[1][1][nx][ny],ww[1][2][nx][ny],
								ww[1][3][nx][ny],ww[1][4][nx][ny]);
				w_[0][0][nx][ny]=w[0][0][nx][ny]+x3[nx][ny][0]*dt;
				w_[1][0][nx][ny]=w[1][0][nx][ny]+x3[nx][ny][1]*dt;
			}
		}
		ww=XAnalysis.pDiffS(w_[0][0],w_[1][0],N,dx,dy);
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	x4[nx][ny]=diff(ww[0][0][nx][ny],ww[0][1][nx][ny],ww[0][2][nx][ny],
								ww[0][3][nx][ny],ww[0][4][nx][ny],
								ww[1][0][nx][ny],ww[1][1][nx][ny],ww[1][2][nx][ny],
								ww[1][3][nx][ny],ww[1][4][nx][ny]);
			}
		}
		for(int i=0;i<2;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	ww[i][0][nx][ny]=w[i][0][nx][ny]+(x1[nx][ny][i]
					+2*x2[nx][ny][i]+2*x3[nx][ny][i]+x4[nx][ny][i])/6*dt;
				}
			}
		}
		return XAnalysis.pDiffS(ww[0][0],ww[1][0],N,dx,dy);
	}

	public F0512a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"łPȔgUɂ鎞ԃJIX");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0512a app=new F0512a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double getX(int nx){return x_min+dx*nx;}
	private double getY(int ny){return y_min+dy*ny;}
	private int getNx(double x){return XMath.fint((x-x_min)/dx);}
	private int getNy(double y){return XMath.fint((y-y_min)/dy);}

	private double setSx(int sx){return dx*sx+mx;}
	private double setSy(int sy){return dy*sy+my;}
	private int getSx(double x){return XMath.fint((x-mx)/dx);}
	private int getSy(double y){return XMath.fint((y-my)/dy);}
}