// t@f|[̐Uqɂ郊~bgTCN

package f05;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0513 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int NL=50000,FR=200,n=5;
	double Div=1.0E4,dt=0.01;
	double k=0.5;
	double[]p0={1.0,0.0};
	double[]FP={0.0,0.0};
	double u_min=-2.5,u_max=2.5;
	double v_min=-2.5,v_max=2.5;
	double Ax=(u_max-u_min)/(2*FR);
	double Bx=(u_max+u_min)/2;
	double Ay=(v_max-v_min)/(2*FR);
	double By=(v_max+v_min)/2;

	private double[]diff(double[]x,int n)
	{	double[]xx=new double[n];
		xx[0]=x[1];
		xx[1]=-x[0]+k*(1-x[0]*x[0])*x[1];
		return xx;
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-70-1,FR+20+1,FR+20+1,-FR-60-1,XColor.Color16[0]);

		double[]p=new double[2];
		for(int sx=-FR;sx<=FR;sx++)
		{	p[0]=setSx(sx);
			for(int sy=-FR;sy<=FR;sy++)
			{	p[1]=setSy(sy);
				double[]pp=diff(p,2);
				if(pp[0]>=0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[1]);
				if(pp[0]>=0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[2]);
				if(pp[0]<0&&pp[1]<0)
					XG.pixel(sx,sy,XColor.Color16[6]);
				if(pp[0]<0&&pp[1]>=0)
					XG.pixel(sx,sy,XColor.Color16[4]);
			}
		}

		double D=2.0*FR/n;
		for(int i=0;i<n;i++)
			XG.line(-FR+XMath.fint((2*i+1)*D/2),-FR,-FR+XMath.fint((2*i+1)*D/2),FR,XColor.Color16[8]);
		for(int i=0;i<n;i++)
			XG.line(-FR,-FR+XMath.fint((2*i+1)*D/2),FR,-FR+XMath.fint((2*i+1)*D/2),XColor.Color16[8]);

		p=p0;
		Point sp_=new Point(getSx(p[0]),getSy(p[1]));
		XG.plus(sp_,4,XColor.Color16[0],3);
		for(int n=0;n<NL;n++)
		{	double[]pp=rungeKutta(p,2);
			p=pp;
			double p2=p[0]*p[0]+p[1]*p[1];
			if(p2>=Div)
				break;
			Point sp=new Point(getSx(p[0]),getSy(p[1]));
			if(Math.abs(sp.x)<=FR&&Math.abs(sp.y)<=FR
				&&Math.abs(sp_.x)<=FR&&Math.abs(sp_.y)<=FR)
				XG.line(sp_,sp,XColor.Color16[0]);
			sp_=sp;
		}

		XG.rectangle(-FR,FR,FR,-FR,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR+1,FR+1,-FR-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR-1,FR-1,-FR+1,XColor.Color16[0]);

		XG.cross(getSx(FP[0]),getSy(FP[1]),3,XColor.Color16[0],3);
		XG.string2(getSx(FP[0])+4,getSy(FP[1])-28,"F",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string2(2*FR/5-11,-FR-52,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-4*FR/5-34,-FR-32,""+XMath.fdouble((9*u_min+u_max)/10,1),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-9,-FR-32,""+XMath.fint((u_min+u_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(4*FR/5-23,-FR-32,""+XMath.fdouble((u_min+9*u_max)/10,1),XColor.Color16[0],
				"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-2*FR/5+11,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-61,-4*FR/5-12,""+XMath.fdouble((9*v_min+v_max)/10,1),XColor.Color16[0],
				"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,-12,""+XMath.fint((v_min+v_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,4*FR/5-12,""+XMath.fdouble((v_min+9*v_max)/10,1),XColor.Color16[0],
				"Arial",Font.PLAIN,32);

		XG.string(10,140,"k="+k,XColor.Color16[0],16);
		XG.string(10,200,"p0=("+p0[0]+","+p0[1]+")",XColor.Color16[0],16);
		XG.string(10,300,"FP=("+XMath.fdouble(FP[0],3)+","
			+XMath.fdouble(FP[1],3)+")",XColor.Color16[0],16);
		XG.string(10,400,"NL="+NL,XColor.Color16[0],16);
		XG.string(10,420,"dt="+dt,XColor.Color16[0],16);
		XG.string(10,440,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
		XG.string(10,460,"v="+v_min+"<<"+v_max,XColor.Color16[0],16);
	}

	private double[]rungeKutta(double[]x,int n)
	{	double[]xx=new double[n];
		double[]x1=new double[n];
		x1=diff(x,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x1[i]/2*dt;
		double[]x2=new double[n];
		x2=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x2[i]/2*dt;
		double[]x3=new double[n];
		x3=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+x3[i]*dt;
		double[]x4=new double[n];
		x4=diff(xx,n);
		for(int i=0;i<n;i++)
			xx[i]=x[i]+(x1[i]+2*x2[i]+2*x3[i]+x4[i])/6*dt;
		return xx;
	}

	public F0513()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"t@f|[̐Uqɂ郊~bgTCN");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
		XG.set0(FC,1);
	}

	public static void main(String[]argv)
	{	F0513 app=new F0513();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}