// XAlgebraF㐔wNX

package xxx;

public final class XAlgebra
{	// 2̉
	public static double[][]roots2dEq(double a,double b)
	{	double[][]x=new double[2][2];
		double d=a*a-4.0*b;
		double r;
		if(d>=0.0)
		{	r=Math.sqrt(d);
			x[0][0]=(-a+r)/2.0;
			x[1][0]=(-a-r)/2.0;
			if(x[0][0]<x[1][0])
			{   double[]dumy=x[0];x[0]=x[1];x[1]=dumy;
			}
			x[0][1]=0.0;
			x[1][1]=0.0;
		}
		else
		{	r=Math.sqrt(-d);
			x[0][0]=-a/2.0;
			x[0][1]=r/2.0;
			x[1][0]=-a/2.0;
			x[1][1]=-r/2.0;
		}
		return x;
	}
	// 3̉
	public static double[][]roots3dEq(double a,double b,double c)
	{	double[][]x=new double[3][2];
		double k=a/3.0,Inf=1.0E6;
		double p=-a*a/3.0+b,q=2.0*a*a*a/27.0-a*b/3.0+c;
		double d=q*q/4.0+p*p*p/27.0;
		double r;
		if(d>=0.0)
		{	r=Math.sqrt(d);
			double s1=Math.pow(Math.abs(-q/2.0+r),1.0/3.0);
			if(-q/2.0+r<0.0)
				s1=-s1;
			double s2=Math.pow(Math.abs(-q/2.0-r),1.0/3.0);
			if(-q/2.0-r<0.0)
				s2=-s2;
			x[0][0]=-k+s1+s2;
			x[0][1]=0.0;
			x[1][0]=-k-(s1+s2)/2;
			x[1][1]=Math.sqrt(3.0)*Math.abs(s1-s2)/2;
			x[2][0]=-k-(s1+s2)/2;
			x[2][1]=-Math.sqrt(3.0)*Math.abs(s1-s2)/2;
		}
		else
		{	r=Math.sqrt(-d);
			double s=Math.pow(q*q/4.0+r*r,1.0/6.0),th1,th2;
			if(Math.abs(q)<1.0/Inf)
			{	th1=Math.PI/2;
				th2=-Math.PI/2;
			}
			else
			{	th1=Math.atan2(r,-q/2.0);
				th2=Math.atan2(-r,-q/2.0);
			}
			x[0][0]=-k+s*(Math.cos(th1/3.0)+Math.cos(th2/3.0));
			x[1][0]=-k+s*(Math.cos((2*Math.PI+th1)/3.0)
				+Math.cos((4*Math.PI+th2)/3.0));
			x[2][0]=-k+s*(Math.cos((4*Math.PI+th1)/3.0)
				+Math.cos((2*Math.PI+th2)/3.0));
			for(int i=0;i<2;i++)
			{	for(int j=i+1;j<3;j++)
				{	if(x[i][0]<x[j][0])
					{   double[]dumy=x[i];x[i]=x[j];x[j]=dumy;
					}
				}
			}
			x[0][1]=0.0;
			x[1][1]=0.0;
			x[2][1]=0.0;
		}
		return x;
	}
	// 4̉
	public static double[][]roots4dEq(double a,double b,double c,double d)
	{	double[][]x=new double[4][2];
		double[][]xr=new double[12][2];
		double[][]xi=new double[12][2];
		double[][]t3=new double[3][2];
		double[][]t2=new double[2][2];
		double k=a/4.0,Inf=1.0E6;
		double p=-3.0*a*a/8.0+b,q=a*a*a/8.0-a*b/2.0+c;
		double r=-3.0*a*a*a*a/256.0+a*a*b/16.0-a*c/4.0+d;
		double a3,b3,c3,r2,a2,b2;
		for(int i=0;i<4;i++)
		{	x[i][0]=-Inf;
			x[i][1]=-Inf;
		}
		for(int i=0;i<12;i++)
		{	xr[i][0]=-Inf;
			xr[i][1]=-Inf;
			xi[i][0]=-Inf;
			xi[i][1]=-Inf;
		}
		a3=5.0*p/2.0;b3=2.0*p*p-r;c3=(4*p*p*p-4*p*r-q*q)/8.0;
		t3=roots3dEq(a3,b3,c3);
		for(int i=0;i<3;i++)
		{	if(Math.abs(t3[i][1])<1.0/Inf)
			{	r2=(p+t3[i][0])*(p+t3[i][0])-r;
				if(r2>=0.0)
				{	b2=Math.sqrt(r2);
					if(Math.abs(b2)<1.0/Inf)
						a2=Math.sqrt(p+2*t3[i][0]);
					else
						a2=-q/(2.0*b2);
					t2=roots2dEq(a2,p+t3[i][0]+b2);
					if(Math.abs(t2[0][1])<1.0/Inf)
					{	xr[4*i][0]=t2[0][0]-k;
						xr[4*i][1]=t2[0][1];
						xr[4*i+1][0]=t2[1][0]-k;
						xr[4*i+1][1]=t2[1][1];
					}
					else
					{	xi[4*i][0]=t2[0][0]-k;
						xi[4*i][1]=t2[0][1];
						xi[4*i+1][0]=t2[1][0]-k;
						xi[4*i+1][1]=t2[1][1];
					}
					t2=roots2dEq(-a2,p+t3[i][0]-b2);
					if(Math.abs(t2[0][1])<1.0/Inf)
					{	xr[4*i+2][0]=t2[0][0]-k;
						xr[4*i+2][1]=t2[0][1];
						xr[4*i+3][0]=t2[1][0]-k;
						xr[4*i+3][1]=t2[1][1];
					}
					else
					{	xi[4*i+2][0]=t2[0][0]-k;
						xi[4*i+2][1]=t2[0][1];
						xi[4*i+3][0]=t2[1][0]-k;
						xi[4*i+3][1]=t2[1][1];
					}
				}
			}
		}
		for(int i=0;i<11;i++)
		{	for(int j=i+1;j<12;j++)
			{	if(Math.abs(xr[i][0]-xr[j][0])<1.0/Inf&&
					Math.abs(xr[i][1]-xr[j][1])<1.0/Inf)
				{	xr[j][0]=-Inf;
					xr[j][1]=-Inf;
				}
			}
		}
		for(int i=0;i<11;i++)
		{	for(int j=i+1;j<12;j++)
			{	if(xr[i][0]<xr[j][0])
				{   double[]dumy=xr[i];xr[i]=xr[j];xr[j]=dumy;
				}
			}
		}
		for(int i=0;i<4;i++)
		{	if(xr[i][0]>-Inf/2)
				x[i]=xr[i];
		}
		for(int i=0;i<11;i++)
		{	for(int j=i+1;j<12;j++)
			{	if(Math.abs(xi[i][0]-xi[j][0])<1.0/Inf&&
					Math.abs(xi[i][1]-xi[j][1])<1.0/Inf)
				{	xi[j][0]=-Inf;
					xi[j][1]=-Inf;
				}
			}
		}
		for(int i=0;i<11;i++)
		{	for(int j=i+1;j<12;j++)
			{	if(xi[i][0]<xi[j][0])
				{   double[]dumy=xi[i];xi[i]=xi[j];xi[j]=dumy;
				}
			}
		}
		if(x[0][1]!=0.0)
		{	for(int i=0;i<4;i++)
				x[i]=xi[i];
		}
		else
		{	if(x[2][1]!=0.0)
			{	for(int i=0;i<2;i++)
					x[i+2]=xi[i];
			}
		}
		return x;
	}
	// 2A1̉
	public static double[]roots2v1dEq(double[][]A)
	{	double[]x=new double[2];
		x[0]=(A[0][2]*A[1][1]-A[1][2]*A[0][1])/(A[0][0]*A[1][1]-A[1][0]*A[0][1]);
		x[1]=(A[0][2]-x[0]*A[0][0])/A[0][1];
		return x;
	}
	// 3A1̉
	public static double[]roots3v1dEq(double[][]A)
	{	double[]x=new double[3];
		double[][]B=new double[2][3];
		B[0][0]=A[0][0]*A[1][2]-A[1][0]*A[0][2];
		B[0][1]=A[0][1]*A[1][2]-A[1][1]*A[0][2];
		B[0][2]=A[0][3]*A[1][2]-A[1][3]*A[0][2];
		B[1][0]=A[0][0]*A[2][2]-A[2][0]*A[0][2];
		B[1][1]=A[0][1]*A[2][2]-A[2][1]*A[0][2];
		B[1][2]=A[0][3]*A[2][2]-A[2][3]*A[0][2];
		x[0]=(B[0][2]*B[1][1]-B[1][2]*B[0][1])/(B[0][0]*B[1][1]-B[1][0]*B[0][1]);
		x[1]=(B[0][2]-x[0]*B[0][0])/B[0][1];
		x[2]=(A[0][3]-x[0]*A[0][0]-x[1]*A[0][1])/A[0][2];
		return x;
	}
	// Ώ̍s^A1̉...Cholesky@(1a)
	public static double[]cholesky(int[][]A,double[]f,int N)
	{	double[][]B=new double[N][N];
		for(int i=0;i<N;i++)
			for(int j=0;j<N;j++)
				B[i][j]=(double)A[i][j];
		return cholesky(B,f);
	}
	// Ώ̍s^A1̉...Cholesky@(1b)
	public static double[]cholesky(int[][]A,double[]f)
	{	return cholesky(A,f,f.length);
	}
	// Ώ̍s^A1̉...Cholesky@(2a)
	public static double[]cholesky(double[][]A,double[]f,int N)
	{	double[]x=new double[N];
		double[]y=new double[N];
		double[][]B=new double[N][N];
		B[0][0]=A[0][0];
		for(int i=1;i<N;i++)
			B[i][0]=A[i][0]/B[0][0];
		for(int i=1;i<N;i++)
		{	double s=0.0;
			for(int j=0;j<i;j++)
				s=s+B[i][j]*B[i][j]*B[j][j];
			B[i][i]=A[i][i]-s;
			for(int j=i+1;j<N;j++)
			{	double t=0.0;
				for(int k=0;k<i;k++)
					t=t+B[i][k]*B[j][k]*B[k][k];
				B[j][i]=(A[j][i]-t)/B[i][i];
			}
		}

		for(int i=0;i<N;i++)
		{	double s=0.0;
			for(int j=0;j<i;j++)
				s=s+B[i][j]*y[j];
			y[i]=f[i]-s;
		}
		for(int i=N-1;i>=0;i--)
		{	double s=0.0;
			for(int j=i+1;j<N;j++)
				s=s+B[j][i]*x[j];
			x[i]=y[i]/B[i][i]-s;
		}
		return x;
	}
	// Ώ̍s^A1̉...Cholesky@(2b)
	public static double[]cholesky(double[][]A,double[]f)
	{	return cholesky(A,f,f.length);
	}
	// 2~2šŗLl
	public static double[][]eigenValues22Mr(double[][]A)
	{	double Tr=A[0][0]+A[1][1];
		double Dt=A[0][0]*A[1][1]-A[0][1]*A[1][0];
		return roots2dEq(-Tr,Dt);
	}
	// 3~3šŗLl
	public static double[][]eigenValues33Mr(double[][]A)
	{	double Tr=A[0][0]+A[1][1]+A[2][2];
		double Dt=A[0][0]*A[1][1]*A[2][2]+A[0][1]*A[1][2]*A[2][0]
				 +A[0][2]*A[1][0]*A[2][1]-A[0][0]*A[1][2]*A[2][1]
				 -A[0][1]*A[1][0]*A[2][2]-A[0][2]*A[1][1]*A[2][0];
		double AA=A[0][0]*A[1][1]+A[0][0]*A[2][2]+A[1][1]*A[2][2]
				 -A[0][1]*A[1][0]-A[0][2]*A[2][0]-A[1][2]*A[2][1];
		return roots3dEq(-Tr,AA,-Dt);
	}
	// 4~4šŗLl
	public static double[][]eigenValues44Mr(double[][]A)
	{	double B2=A[1][1]+A[2][2]+A[3][3];
		double B1=A[1][1]*A[2][2]+A[1][1]*A[3][3]+A[2][2]*A[3][3]
				 -A[1][2]*A[2][1]-A[1][3]*A[3][1]-A[2][3]*A[3][2];
		double B0=A[1][1]*A[2][2]*A[3][3]-A[1][1]*A[2][3]*A[3][2]
				 +A[1][2]*A[2][3]*A[3][1]-A[1][2]*A[2][1]*A[3][3]
				 +A[1][3]*A[2][1]*A[3][2]-A[1][3]*A[2][2]*A[3][1];
		double B03=-(A[0][0]+B2);
		double B02=A[0][0]*B2+B1;
		double B01=-(A[0][0]*B1+B0);
		double B00=A[0][0]*B0;
		double B12=-A[0][1]*A[1][0];
		double B11=A[0][1]*(A[1][0]*A[2][2]+A[1][0]*A[3][3]-A[1][2]*A[2][0]-A[1][3]*A[3][0]);
		double B10=-A[0][1]*(A[1][0]*A[2][2]*A[3][3]-A[1][0]*A[2][3]*A[3][2]
							+A[1][2]*A[2][3]*A[3][0]-A[1][2]*A[2][0]*A[3][3]
							+A[1][3]*A[2][0]*A[3][2]-A[1][3]*A[2][2]*A[3][0]);
		double B22=-A[0][2]*A[2][0];
		double B21=A[0][2]*(A[2][0]*A[1][1]+A[2][0]*A[3][3]-A[1][0]*A[2][1]-A[2][3]*A[3][0]);
		double B20=-A[0][2]*(A[1][0]*A[2][3]*A[3][1]-A[1][0]*A[2][1]*A[3][3]
							+A[1][1]*A[2][0]*A[3][3]-A[1][1]*A[2][3]*A[3][0]
							+A[1][3]*A[2][1]*A[3][0]-A[1][3]*A[2][0]*A[3][1]);
		double B32=-A[0][3]*A[3][0];
		double B31=A[0][3]*(A[3][0]*A[1][1]+A[3][0]*A[2][2]-A[1][0]*A[3][1]-A[2][0]*A[3][2]);
		double B30=-A[0][3]*(A[1][0]*A[2][1]*A[3][2]-A[1][0]*A[2][2]*A[3][1]
							+A[1][1]*A[2][2]*A[3][0]-A[1][1]*A[2][0]*A[3][2]
							+A[1][2]*A[2][0]*A[3][1]-A[1][2]*A[2][1]*A[3][0]);
		return roots4dEq(B03,B02+B12+B22+B32,B01+B11+B21+B31,B00+B10+B20+B30);
	}
}